﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text.RegularExpressions;
using DataContracts;
namespace Ato.EN.IntegrationServices.CodeGenerationIITR
{
    public partial class IITR2021Validator
    {
        private const decimal SlsUntaxedPlanCapThreshold = 1480000;
        private const decimal SlsLifetimeCapThreshold = 205000;
        private const decimal EtpCapForLifeDeathBenefitThreshold = 205000;

        #region Cross Form Rules - not supported yet

        #region VR.ATO.GEN.438022
        protected void VRATOGEN438022(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.GEN.438022

        #region VR.ATO.GEN.438023
        protected void VRATOGEN438023(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.GEN.438023

        #region VR.ATO.GEN.438024
        protected void VRATOGEN438024(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.GEN.438024

        #region VR.ATO.GEN.438025
        protected void VRATOGEN438025(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.GEN.438025

        #region VR.ATO.GEN.438026
        protected void VRATOGEN438026(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.GEN.438026

        #region VR.ATO.GEN.438027
        protected void VRATOGEN438027(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.GEN.438027

        #region VR.ATO.IITR.000639
        protected void VRATOIITR000639(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.000639

        #region VR.ATO.IITR.000641
        protected void VRATOIITR000641(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.000641

        #region VR.ATO.IITR.000642
        protected void VRATOIITR000642(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.000642

        #region VR.ATO.IITR.000643
        protected void VRATOIITR000643(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.000643

        #region VR.ATO.IITR.000644
        protected void VRATOIITR000644(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.000644

        #region VR.ATO.IITR.000651
        protected void VRATOIITR000651(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.000651
         
        #region VR.ATO.IITR.300041
        protected void VRATOIITR300041(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.300041

        #region VR.ATO.IITR.300042
        protected void VRATOIITR300042(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.300042

        #region VR.ATO.IITR.300043
        protected void VRATOIITR300043(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.300043

        #region VR.ATO.IITR.300044
        protected void VRATOIITR300044(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.300044

        #region VR.ATO.IITR.300045
        protected void VRATOIITR300045(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.300045

        #region VR.ATO.IITR.300046
        protected void VRATOIITR300046(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.300046

        #region VR.ATO.IITR.300047
        protected void VRATOIITR300047(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.300047

        #region VR.ATO.IITR.300048
        protected void VRATOIITR300048(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.300048

        #region VR.ATO.IITR.300049
        protected void VRATOIITR300049(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.300049

        #region VR.ATO.IITR.300050
        protected void VRATOIITR300050(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.300050

        #region VR.ATO.IITR.300051
        protected void VRATOIITR300051(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.300051

        #region VR.ATO.IITR.300052
        protected void VRATOIITR300052(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.300052

        #region VR.ATO.IITR.300084
        protected void VRATOIITR300084(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.300084

        #region VR.ATO.IITR.300085
        protected void VRATOIITR300085(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.300085

        #region VR.ATO.IITR.300086
        protected void VRATOIITR300086(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.300086

        #region VR.ATO.IITR.300093
        protected void VRATOIITR300093(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.300093

        #region VR.ATO.IITR.310021
        protected void VRATOIITR310021(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.310021

        #region VR.ATO.IITR.310037
        protected void VRATOIITR310037(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.310037

        #region VR.ATO.IITR.310039
        protected void VRATOIITR310039(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.310039

        #region VR.ATO.IITR.310063
        protected void VRATOIITR310063(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.310063

        #region VR.ATO.IITR.310066
        protected void VRATOIITR310066(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.310066

        #region VR.ATO.IITR.310067
        protected void VRATOIITR310067(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.310067

        #region VR.ATO.IITR.310068
        protected void VRATOIITR310068(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.310068

        #region VR.ATO.IITR.310069
        protected void VRATOIITR310069(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.310069

        #region VR.ATO.IITR.310070
        protected void VRATOIITR310070(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.310070

        #region VR.ATO.IITR.310071
        protected void VRATOIITR310071(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.310071

        #region VR.ATO.IITR.310083
        protected void VRATOIITR310083(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.310083

        #region VR.ATO.IITR.310084
        protected void VRATOIITR310084(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.310084
        
        #region VR.ATO.IITR.310088
        protected void VRATOIITR310088(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.310088

        #region VR.ATO.IITR.310089
        protected void VRATOIITR310089(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.310089

        #region VR.ATO.IITR.310090
        protected void VRATOIITR310090(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.310090

        #region VR.ATO.IITR.310093
        protected void VRATOIITR310093(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.310093

        #region VR.ATO.IITR.310094
        protected void VRATOIITR310094(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.310094

        #region VR.ATO.IITR.310095
        protected void VRATOIITR310095(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.310095

        #region VR.ATO.IITR.400059
        protected void VRATOIITR400059(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400059

        #region VR.ATO.IITR.400059
        protected void VRATOIITR400059_(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400059

        #region VR.ATO.IITR.400059
        protected void VRATOIITR400059__(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400059

        #region VR.ATO.IITR.400059
        protected void VRATOIITR400059___(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400059

        #region VR.ATO.IITR.400059
        protected void VRATOIITR400059____(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400059

        #region VR.ATO.IITR.400059
        protected void VRATOIITR400059_____(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400059

        #region VR.ATO.IITR.400059
        protected void VRATOIITR400059______(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400059

        #region VR.ATO.IITR.400059
        protected void VRATOIITR400059_______(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400059

        #region VR.ATO.IITR.400059
        protected void VRATOIITR400059________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400059

        #region VR.ATO.IITR.400059
        protected void VRATOIITR400059_________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400059

        #region VR.ATO.IITR.400059
        protected void VRATOIITR400059__________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400059

        #region VR.ATO.IITR.400059
        protected void VRATOIITR400059___________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400059

        #region VR.ATO.IITR.400059
        protected void VRATOIITR400059____________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400059

        #region VR.ATO.IITR.400059
        protected void VRATOIITR400059_____________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400059

        #region VR.ATO.IITR.400059
        protected void VRATOIITR400059______________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400059

        #region VR.ATO.IITR.400059
        protected void VRATOIITR400059_______________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400059

        #region VR.ATO.IITR.400059
        protected void VRATOIITR400059________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400059

        #region VR.ATO.IITR.400059
        protected void VRATOIITR400059_________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400059

        #region VR.ATO.IITR.400059
        protected void VRATOIITR400059__________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400059

        #region VR.ATO.IITR.400059
        protected void VRATOIITR400059___________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400059

        #region VR.ATO.IITR.400059
        protected void VRATOIITR400059____________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400059

        #region VR.ATO.IITR.400059
        protected void VRATOIITR400059_____________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400059

        #region VR.ATO.IITR.400059
        protected void VRATOIITR400059______________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400059

        #region VR.ATO.IITR.400059
        protected void VRATOIITR400059_______________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400059

        #region VR.ATO.IITR.400059
        protected void VRATOIITR400059________________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400059

        #region VR.ATO.IITR.400059
        protected void VRATOIITR400059_________________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400059

        #region VR.ATO.IITR.400059
        protected void VRATOIITR400059__________________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400059

        #region VR.ATO.IITR.400060
        protected void VRATOIITR400060(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400060

        #region VR.ATO.IITR.400060
        protected void VRATOIITR400060_(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400060

        #region VR.ATO.IITR.400060
        protected void VRATOIITR400060__(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400060

        #region VR.ATO.IITR.400060
        protected void VRATOIITR400060___(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400060

        #region VR.ATO.IITR.400060
        protected void VRATOIITR400060____(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400060

        #region VR.ATO.IITR.400060
        protected void VRATOIITR400060_____(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400060

        #region VR.ATO.IITR.400060
        protected void VRATOIITR400060______(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400060

        #region VR.ATO.IITR.400060
        protected void VRATOIITR400060_______(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400060

        #region VR.ATO.IITR.400060
        protected void VRATOIITR400060________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400060

        #region VR.ATO.IITR.400060
        protected void VRATOIITR400060_________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400060

        #region VR.ATO.IITR.400060
        protected void VRATOIITR400060__________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400060

        #region VR.ATO.IITR.400060
        protected void VRATOIITR400060___________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400060

        #region VR.ATO.IITR.400060
        protected void VRATOIITR400060____________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400060

        #region VR.ATO.IITR.400060
        protected void VRATOIITR400060_____________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400060

        #region VR.ATO.IITR.400060
        protected void VRATOIITR400060______________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400060

        #region VR.ATO.IITR.400060
        protected void VRATOIITR400060_______________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400060

        #region VR.ATO.IITR.400060
        protected void VRATOIITR400060________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400060

        #region VR.ATO.IITR.400060
        protected void VRATOIITR400060_________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400060

        #region VR.ATO.IITR.400060
        protected void VRATOIITR400060__________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400060

        #region VR.ATO.IITR.400060
        protected void VRATOIITR400060___________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400060

        #region VR.ATO.IITR.400060
        protected void VRATOIITR400060____________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400060

        #region VR.ATO.IITR.400060
        protected void VRATOIITR400060_____________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400060

        #region VR.ATO.IITR.400060
        protected void VRATOIITR400060______________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400060

        #region VR.ATO.IITR.400060
        protected void VRATOIITR400060_______________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400060

        #region VR.ATO.IITR.400060
        protected void VRATOIITR400060________________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400060

        #region VR.ATO.IITR.400060
        protected void VRATOIITR400060_________________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400060

        #region VR.ATO.IITR.400060
        protected void VRATOIITR400060__________________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.400060

        #region VR.ATO.IITR.600014
        protected void VRATOIITR600014(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.600014

        #region VR.ATO.IITR.600024
        protected void VRATOIITR600024(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.600024

        #region VR.ATO.IITR.600031
        protected void VRATOIITR600031(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.600031

        #region VR.ATO.IITR.600046
        protected void VRATOIITR600046(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.600046

        #region VR.ATO.IITR.700304
        protected void VRATOIITR700304(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.700304

        #region VR.ATO.IITR.730000
        protected void VRATOIITR730000(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730000

        #region VR.ATO.IITR.730001
        protected void VRATOIITR730001(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730001

        #region VR.ATO.IITR.730002
        protected void VRATOIITR730002(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730002

        #region VR.ATO.IITR.730003
        protected void VRATOIITR730003(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730003

        #region VR.ATO.IITR.730050
        protected void VRATOIITR730050(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730050

        #region VR.ATO.IITR.730051
        protected void VRATOIITR730051(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730051

        #region VR.ATO.IITR.730052
        protected void VRATOIITR730052(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730052

        #region VR.ATO.IITR.730053
        protected void VRATOIITR730053(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730053

        #region VR.ATO.IITR.730054
        protected void VRATOIITR730054(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730053

        #region VR.ATO.IITR.730055
        protected void VRATOIITR730055(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730055

        #region VR.ATO.IITR.730056
        protected void VRATOIITR730056(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730730056053

        #region VR.ATO.IITR.730057
        protected void VRATOIITR730057(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730057

        #region VR.ATO.IITR.730058
        protected void VRATOIITR730058(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730058

        #region VR.ATO.IITR.730059
        protected void VRATOIITR730059(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730059

        #region VR.ATO.IITR.730100
        protected void VRATOIITR730100(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730100

        #region VR.ATO.IITR.730101
        protected void VRATOIITR730101(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730101

        #region VR.ATO.IITR.730102
        protected void VRATOIITR730102(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }

        #endregion // VR.ATO.IITR.730102

        #region VR.ATO.IITR.730103
        protected void VRATOIITR730103(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730103

        #region VR.ATO.IITR.730104
        protected void VRATOIITR730104(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730104

        #region VR.ATO.IITR.730105
        protected void VRATOIITR730105(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730105

        #region VR.ATO.IITR.730106
        protected void VRATOIITR730106(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730106

        #region VR.ATO.IITR.730107
        protected void VRATOIITR730107(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730107

        #region VR.ATO.IITR.730150
        protected void VRATOIITR730150(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730150

        #region VR.ATO.IITR.730200
        protected void VRATOIITR730200(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730200

        #region VR.ATO.IITR.730201
        protected void VRATOIITR730201(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730201

        #region VR.ATO.IITR.730202
        protected void VRATOIITR730202(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730202

        #region VR.ATO.IITR.730203
        protected void VRATOIITR730203(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730203

        #region VR.ATO.IITR.730204
        protected void VRATOIITR730204(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730204

        #region VR.ATO.IITR.730205
        protected void VRATOIITR730205(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730205

        #region VR.ATO.IITR.730206
        protected void VRATOIITR730206(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730206

        #region VR.ATO.IITR.730207
        protected void VRATOIITR730207(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730207

        #region VR.ATO.IITR.730208
        protected void VRATOIITR730208(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730208

        #region VR.ATO.IITR.730209
        protected void VRATOIITR730209(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730209

        #region VR.ATO.IITR.730210
        protected void VRATOIITR730210(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730210

        #region VR.ATO.IITR.730211
        protected void VRATOIITR730211(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730211

        #region VR.ATO.IITR.730212
        protected void VRATOIITR730212(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730212

        #region VR.ATO.IITR.730213
        protected void VRATOIITR730213(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730213

        #region VR.ATO.IITR.730214
        protected void VRATOIITR730214(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730214

        #region VR.ATO.IITR.730215
        protected void VRATOIITR730215(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730215

        #region VR.ATO.IITR.730216
        protected void VRATOIITR730216(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730216

        #region VR.ATO.IITR.730217
        protected void VRATOIITR730217(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730217

        #region VR.ATO.IITR.730218
        protected void VRATOIITR730218(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730218

        #region VR.ATO.IITR.730219
        protected void VRATOIITR730219(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730219

        #region VR.ATO.IITR.730220
        protected void VRATOIITR730220(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730220

        #region VR.ATO.IITR.730221
        protected void VRATOIITR730221(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730221

        #region VR.ATO.IITR.730300
        protected void VRATOIITR730300(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730300

        #region VR.ATO.IITR.730301
        protected void VRATOIITR730301(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730301

        #region VR.ATO.IITR.730302
        protected void VRATOIITR730302(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730302

        #region VR.ATO.IITR.730304
        protected void VRATOIITR730304(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730304

        #region VR.ATO.IITR.730305
        protected void VRATOIITR730305(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730305

        #region VR.ATO.IITR.730306
        protected void VRATOIITR730306(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730306

        #region VR.ATO.IITR.730307
        protected void VRATOIITR730307(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730307

        #region VR.ATO.IITR.730308
        protected void VRATOIITR730308(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730308
         
        #region VR.ATO.IITR.730310
        protected void VRATOIITR730310(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730310

        #region VR.ATO.IITR.730311
        protected void VRATOIITR730311(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730311

        #region VR.ATO.IITR.730311
        protected void VRATOIITR730311_(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730311

        #region VR.ATO.IITR.730311
        protected void VRATOIITR730311__(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730311

        #region VR.ATO.IITR.730311
        protected void VRATOIITR730311___(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730311

        #region VR.ATO.IITR.730311
        protected void VRATOIITR730311____(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730311

        #region VR.ATO.IITR.730311
        protected void VRATOIITR730311_____(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730311

        #region VR.ATO.IITR.730311
        protected void VRATOIITR730311______(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730311

        #region VR.ATO.IITR.730311
        protected void VRATOIITR730311_______(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730311

        #region VR.ATO.IITR.730311
        protected void VRATOIITR730311________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730311

        #region VR.ATO.IITR.730311
        protected void VRATOIITR730311_________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730311

        #region VR.ATO.IITR.730311
        protected void VRATOIITR730311__________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730311

        #region VR.ATO.IITR.730311
        protected void VRATOIITR730311___________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730311

        #region VR.ATO.IITR.730311
        protected void VRATOIITR730311____________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730311

        #region VR.ATO.IITR.730311
        protected void VRATOIITR730311_____________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730311

        #region VR.ATO.IITR.730311
        protected void VRATOIITR730311______________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730311

        #region VR.ATO.IITR.730311
        protected void VRATOIITR730311_______________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730311

        #region VR.ATO.IITR.730311
        protected void VRATOIITR730311________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730311

        #region VR.ATO.IITR.730311
        protected void VRATOIITR730311_________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730311

        #region VR.ATO.IITR.730311
        protected void VRATOIITR730311__________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730311

        #region VR.ATO.IITR.730311
        protected void VRATOIITR730311___________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730311

        #region VR.ATO.IITR.730311
        protected void VRATOIITR730311____________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730311

        #region VR.ATO.IITR.730311
        protected void VRATOIITR730311_____________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730311

        #region VR.ATO.IITR.730311
        protected void VRATOIITR730311______________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730311

        #region VR.ATO.IITR.730311
        protected void VRATOIITR730311_______________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730311

        #region VR.ATO.IITR.730311
        protected void VRATOIITR730311________________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730311

        #region VR.ATO.IITR.730311
        protected void VRATOIITR730311_________________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730311

        #region VR.ATO.IITR.730311
        protected void VRATOIITR730311__________________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730311

        #region VR.ATO.IITR.730312
        protected void VRATOIITR730312(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730312

        #region VR.ATO.IITR.730312
        protected void VRATOIITR730312_(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730312

        #region VR.ATO.IITR.730312
        protected void VRATOIITR730312__(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730312

        #region VR.ATO.IITR.730312
        protected void VRATOIITR730312___(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730312

        #region VR.ATO.IITR.730312
        protected void VRATOIITR730312____(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730312

        #region VR.ATO.IITR.730312
        protected void VRATOIITR730312_____(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730312

        #region VR.ATO.IITR.730312
        protected void VRATOIITR730312______(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730312

        #region VR.ATO.IITR.730312
        protected void VRATOIITR730312_______(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730312

        #region VR.ATO.IITR.730312
        protected void VRATOIITR730312________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730312

        #region VR.ATO.IITR.730312
        protected void VRATOIITR730312_________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730312

        #region VR.ATO.IITR.730312
        protected void VRATOIITR730312__________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730312

        #region VR.ATO.IITR.730312
        protected void VRATOIITR730312___________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730312

        #region VR.ATO.IITR.730312
        protected void VRATOIITR730312____________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730312

        #region VR.ATO.IITR.730312
        protected void VRATOIITR730312_____________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730312

        #region VR.ATO.IITR.730312
        protected void VRATOIITR730312______________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730312

        #region VR.ATO.IITR.730312
        protected void VRATOIITR730312_______________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730312

        #region VR.ATO.IITR.730312
        protected void VRATOIITR730312________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730312

        #region VR.ATO.IITR.730312
        protected void VRATOIITR730312_________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }

        #endregion // VR.ATO.IITR.730312

        #region VR.ATO.IITR.730312
        protected void VRATOIITR730312__________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730312

        #region VR.ATO.IITR.730312
        protected void VRATOIITR730312___________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730312

        #region VR.ATO.IITR.730312
        protected void VRATOIITR730312____________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730312

        #region VR.ATO.IITR.730312
        protected void VRATOIITR730312_____________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730312

        #region VR.ATO.IITR.730312
        protected void VRATOIITR730312______________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730312

        #region VR.ATO.IITR.730312
        protected void VRATOIITR730312_______________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730312

        #region VR.ATO.IITR.730312
        protected void VRATOIITR730312________________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730312

        #region VR.ATO.IITR.730312
        protected void VRATOIITR730312_________________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730312

        #region VR.ATO.IITR.730312
        protected void VRATOIITR730312__________________________(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730312

        #region VR.ATO.IITR.730313

        protected void VRATOIITR730313(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730313

        #endregion

        #region Manual Rules - Rules marked for manual coding

        #region VR.ATO.IITR.000013

        protected void VRATOIITR000013(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.000013

        #region VR.ATO.IITR.000222

        /* VR.ATO.IITR.000222
        Tax withheld from Australian Government allowances and payments like newstart, youth allowance and austudy payment are greater than or equal to the amount of Australian Government allowances and payments like Newstart, youth allowance and austudy payment.  Check both amounts and correct as necessary.

        Legacy Rule Format:
        (^IITR85 > 0) AND ((^IITR86 = NULL) OR (^IITR86 <= ^IITR85))

        Technical Business Rule Format:
        (^IITR85 > 0) AND ((^IITR86 = NULL) OR (^IITR86 <= ^IITR85))

        Data Elements:

        ^IITR85 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldAustralianGovernmentAllowancesAndPayments.Amount

        ^IITR86 = RP:Income.AustralianGovernmentAllowancesAndPayments.Amount
        */
        protected void VRATOIITR000222(List<ProcessMessageDocument> response, IITR2021 report)
        {
            ProcessMessageDocument processMessage;
            bool assertion;

            assertion = (report.IITR85.GetValueOrDefault() > 0 && (report.IITR86 == null || report.IITR86.GetValueOrDefault() <= report.IITR85.GetValueOrDefault()));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000222",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"'Tax withheld from Australian Government allowances and payments like newstart,...' amount incorrect",
                    LongDescription = @"When an amount above zero is provided for 'Tax withheld from Australian Government allowances and payments like newstart, youth allowance and austudy payment', the amount must be below the amount of 'Australian Government allowances and payments like Newstart, youth allowance and austudy payment'",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldAustralianGovernmentAllowancesAndPayments.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000222" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR85", Value = GetValueOrEmpty(report.IITR85) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR86", Value = GetValueOrEmpty(report.IITR86) });

                response.Add(processMessage);
            }
        }
        #endregion // VR.ATO.IITR.000222

        #region VR.ATO.IITR.000230

        /* VR.ATO.IITR.000230
        Other deductions relating to amounts shown at "Distribution from partnerships less foreign income", "Share of net income from trusts less capital gains, foreign income and franked distributions" and "Franked distributions from trusts" type has been completed without an amount at Other deductions relating to amounts shown at "Distribution from partnerships less foreign income", "Share of net income from trusts less capital gains, foreign income and franked distributions" and "Franked distributions from trusts".
    
        Legacy Rule Format:
        (^IITR265 = NULL OR ^IITR265 = 0) AND (^IITR266 <> NULL)

        Technical Business Rule Format:
        (^IITR265 = NULL OR ^IITR265 = 0) AND (^IITR266 <> NULL)
    
        Data Elements:
    
        ^IITR265 = RP:IncomeTax.Deduction.TrustPartnershipOtherNonPrimaryProductionNet.Amount
    
        ^IITR266 = RP:IncomeTax.Deduction.TrustPartnershipOtherNonPrimaryProductionNet.Code
        */
        protected void VRATOIITR000230(List<ProcessMessageDocument> response, IITR2021 report)
        {
            ProcessMessageDocument processMessage;
            bool assertion;

            assertion = ((report.IITR265 == null || report.IITR265 == 0) && report.IITR266 != null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000230",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"'Other deductions relating to amounts shown at...' amount is invalid",
                    LongDescription = @"When a code has been provided for Other deductions relating to amounts shown at ""Distribution from partnerships less foreign income"", ""Share of net income from trusts less capital gains, foreign income and franked distributions"" and ""Franked distributions from trusts"" type, an amount above zero must be provided for Other deductions relating to amounts shown at ""Distribution from partnerships less foreign income"", ""Share of net income from trusts less capital gains, foreign income and franked distributions"" and ""Franked distributions from trusts""",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.TrustPartnershipOtherNonPrimaryProductionNet.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000230" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR265", Value = GetValueOrEmpty(report.IITR265) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR266", Value = GetValueOrEmpty(report.IITR266) });

                response.Add(processMessage);
            }
        }
        #endregion // VR.ATO.IITR.000230

        #region VR.ATO.IITR.000237

        /* VR.ATO.IITR.000237
        Share of net income from trusts less capital gains, foreign income and franked distributions is greater than zero and the Share of net income from trusts less capital gains, foreign income and franked distributions action code is missing.
    
        Legacy Rule Format:
        (^IITR255 > 0) AND (^IITR256 = NULL)

        Technical Business Rule Format:
        (^IITR255 > 0) AND (^IITR256 = NULL)
    
        Data Elements:
    
        ^IITR256 = RP:Income.TrustLessNetCapitalGainAndForeignIncomeNonPrimaryProductionShare.Code
    
        ^IITR255 = RP:Income.TrustLessNetCapitalGainAndForeignIncomeNonPrimaryProductionShare.Amount
        */
        protected void VRATOIITR000237(List<ProcessMessageDocument> response, IITR2021 report)
        {
            ProcessMessageDocument processMessage;
            bool assertion;

            assertion = (report.IITR255.GetValueOrDefault() > 0 && report.IITR256 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000237",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"'Share of net income from trusts less capital gains... action code' is required",
                    LongDescription = @"When an amount above zero is provided for 'Share of net income from trusts less capital gains, foreign income and franked distributions', 'Share of net income from trusts less capital gains, foreign income and franked distributions action code' is required",
                    Location = "/xbrli:xbrl/tns:Income.TrustLessNetCapitalGainAndForeignIncomeNonPrimaryProductionShare.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000237" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR255", Value = GetValueOrEmpty(report.IITR255) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR256", Value = GetValueOrEmpty(report.IITR256) });

                response.Add(processMessage);
            }
        }
        #endregion // VR.ATO.IITR.000237

        #region VR.ATO.IITR.000604

        /* VR.ATO.IITR.000604
        Private health insurance policy has an entry with Tax claim code "Claiming your spouses share of rebate" then there must be a matching entry with Tax claim code "Claiming your share of rebate". The number of lines with tax claim code "Claiming your spouses share of rebate" must be equal to the number of lines with tax claim code "Claiming your share of rebate" for a particular policy, but this cannot be enforced due to technical constraints.
    
        Legacy Rule Format:
        ^IITR185 = 'Claiming your spouses share of rebate' AND CountOccurrence(^IITR185, ^IITR185 = 'Claiming your share of rebate' WHERE (HasDuplicateValues(^IITR180) AND HasDuplicateValues(^IITR181))) = 0
        
        Technical Business Rule Format:
        ^IITR185 = 'Claiming your spouses share of rebate' AND CountOccurrence(^IITR185, ^IITR185 = 'Claiming your share of rebate' WHERE (HasDuplicateValues(^IITR180) AND HasDuplicateValues(^IITR181))) = 0
            
        Data Elements:
            
        ^IITR185 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.TaxClaim.Code
            
        ^IITR180 = RP.{PHISeqNum}:Identifiers.HealthInsuranceProvider.Identifier
            
        ^IITR181 = RP.{PHISeqNum}:Identifiers.HealthInsuranceMembership.Identifier
        */
        protected void VRATOIITR000604(List<ProcessMessageDocument> response, IITR2021 report)
        {
            ProcessMessageDocument processMessage;
            bool assertion;

            if (report.RPPHISeqNumContextCollection != null)
            {
                foreach (IITR2021.RPPHISeqNumContext rpPHISeqNumContext in report.RPPHISeqNumContextCollection)
                {
                    assertion = (rpPHISeqNumContext.IITR185 == "Claiming your spouses share of rebate" && report.RPPHISeqNumContextCollection.Find(f => f.IITR185 == "Claiming your share of rebate" && f.IITR180 == rpPHISeqNumContext.IITR180 && f.IITR181 == rpPHISeqNumContext.IITR181) == null);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.000604",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Private health insurance details must match where claiming both your and spouse's share of rebate.",
                            Location = "/xbrli:xbrl/tns:IncomeTax.HealthInsurance.TaxClaim.Code[@contextRef='" + rpPHISeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000604" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR180", Value = rpPHISeqNumContext.IITR180 });
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR181", Value = rpPHISeqNumContext.IITR181 });
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR185", Value = rpPHISeqNumContext.IITR185 });

                        response.Add(processMessage);
                    }
                }
            }
        }
        #endregion // VR.ATO.IITR.000604

        #region VR.ATO.IITR.000645

        protected void VRATOIITR000645(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.000645

        #region VR.ATO.IITR.100031
        protected void VRATOIITR100031(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.100031

        #region VR.ATO.IITR.100032
        protected void VRATOIITR100032(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.100032

        #region VR.ATO.IITR.100033
        protected void VRATOIITR100033(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.100033

        #region VR.ATO.IITR.100034
        protected void VRATOIITR100034(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.100034

        #region VR.ATO.IITR.100043
        protected void VRATOIITR100043(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.100043

        #region VR.ATO.IITR.200014
        protected void VRATOIITR200014(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.200014

        #region VR.ATO.IITR.200015
        protected void VRATOIITR200015(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.200015

        #region VR.ATO.IITR.200034
        protected void VRATOIITR200034(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.200034

        #region VR.ATO.IITR.210034

        /* VR.ATO.IITR.210034
        If two or more rows have been entered for one policy, tax claim codes must be the same on all rows except where the tax claim code is "Claiming your spouses share of rebate" or "Covered as dependent child" in any of those rows. Tax claim code(s) must be corrected.
    
        Legacy Rule Format:
        ^IITR185 <> NULL AND NotInSet(^IITR185, '"Claiming your spouses share of rebate","Covered as dependent child"') AND (NotSameValues(^IITR180) WHERE NotInSet(^IITR185, '"Claiming your spouses share of rebate","Covered as dependent child"') OR NotSameValues(^IITR181) WHERE NotInSet(^IITR185, '"Claiming your spouses share of rebate","Covered as dependent child"'))

        Technical Business Rule Format:
        ^IITR185 <> NULL AND NotInSet(^IITR185, '"Claiming your spouses share of rebate","Covered as dependent child"') AND (NotSameValues(^IITR180) WHERE NotInSet(^IITR185, '"Claiming your spouses share of rebate","Covered as dependent child"') OR NotSameValues(^IITR181) WHERE NotInSet(^IITR185, '"Claiming your spouses share of rebate","Covered as dependent child"'))
    
        Data Elements:
    
        ^IITR185 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.TaxClaim.Code
    
        ^IITR180 = RP.{PHISeqNum}:Identifiers.HealthInsuranceProvider.Identifier
    
        ^IITR181 = RP.{PHISeqNum}:Identifiers.HealthInsuranceMembership.Identifier
        */
        protected void VRATOIITR210034(List<ProcessMessageDocument> response, IITR2021 report)
        {
            ProcessMessageDocument processMessage;
            bool assertion;

            if (report.RPPHISeqNumContextCollection != null)
            {
                foreach (IITR2021.RPPHISeqNumContext rpPHISeqNumContext in report.RPPHISeqNumContextCollection)
                {
                    assertion = (report.RPPHISeqNumContextCollection.Find(f => f.IITR180 == rpPHISeqNumContext.IITR180 && f.IITR181 == rpPHISeqNumContext.IITR181 && f.IITR185 != rpPHISeqNumContext.IITR185 && f.IITR185 != "Claiming your spouses share of rebate" && f.IITR185 != "Covered as dependent child") != null && rpPHISeqNumContext.IITR185 != "Claiming your spouses share of rebate" && rpPHISeqNumContext.IITR185 != "Covered as dependent child");
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.210034",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Tax claim code(s) against the same Private Health Insurance policy are incorrect",
                            LongDescription = @"When multiple Private Health Insurance details have been entered against the same policy ('Private health insurance - Health insurer ID' and 'Private health insurance - Health insurer ID'), the 'Tax claim code' must be the same across all the policy entries, except where the 'Tax claim code' is either ""Claiming your spouses share of rebate"" or ""Covered as dependent child""",
                            Location = "/xbrli:xbrl/tns:IncomeTax.HealthInsurance.TaxClaim.Code[@contextRef='" + rpPHISeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.210034" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR180", Value = rpPHISeqNumContext.IITR180 });
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR181", Value = rpPHISeqNumContext.IITR181 });
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR185", Value = rpPHISeqNumContext.IITR185 });

                        response.Add(processMessage);
                    }
                }
            }
        }
        #endregion // VR.ATO.IITR.210034

        #region VR.ATO.IITR.210035

        /* VR.ATO.IITR.210035
        You will need the private health insurance statement to complete the private health insurance policy details. Ensure that you have only entered the amounts shown on the statement at Your premiums eligible for Australian Government rebate and Your Australian Government rebate received. These values are dollar amounts.
    
        Legacy Rule Format:
        (InSet(^IITR185, '"No dependants", "Dependants", "Claiming your share of rebate", "Claiming your spouses share of rebate"')) AND (^IITR183 > 0) AND ((^IITR182 <> NULL AND ^IITR183 >= ^IITR182) OR (^IITR182 = NULL))
        
        Technical Business Rule Format:
        (InSet(^IITR185, '"No dependants", "Dependants", "Claiming your share of rebate", "Claiming your spouses share of rebate"')) AND (^IITR183 > 0) AND ((^IITR182 <> NULL AND ^IITR183 >= ^IITR182) OR (^IITR182 = NULL))
            
        Data Elements:
            
        ^IITR182 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.RebatableComponent.Amount
            
        ^IITR183 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.GovernmentRebateReceived.Amount
            
        ^IITR185 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.TaxClaim.Code
        */
        protected void VRATOIITR210035(List<ProcessMessageDocument> response, IITR2021 report)
        {
            ProcessMessageDocument processMessage;
            bool assertion;

            if (report.RPPHISeqNumContextCollection != null)
            {
                foreach (IITR2021.RPPHISeqNumContext rpphiSeqNumContext in report.RPPHISeqNumContextCollection)
                {
                    assertion = (IsMatch(rpphiSeqNumContext.IITR185, @"^(No dependants|Dependants|Claiming your share of rebate|Claiming your spouses share of rebate)$") && rpphiSeqNumContext.IITR183.GetValueOrDefault() > 0 && (rpphiSeqNumContext.IITR182 != null && rpphiSeqNumContext.IITR183.GetValueOrDefault() >= rpphiSeqNumContext.IITR182.GetValueOrDefault() || rpphiSeqNumContext.IITR182 == null));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.210035",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"'Your premiums eligible for Australian Government rebate' amount is incorrect",
                            LongDescription = @"Refer to your private health insurance statement to complete the private health insurance policy details. Ensure that you have only entered the amounts shown on the statement into the 'Your premiums eligible for Australian Government rebate' and 'Your Australian Government rebate received' amount fields for each policy entry.",
                            Location = "/xbrli:xbrl/tns:IncomeTax.HealthInsurance.RebatableComponent.Amount[@contextRef='" + rpphiSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.210035" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR185", Value = GetValueOrEmpty(rpphiSeqNumContext.IITR185) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR183", Value = GetValueOrEmpty(rpphiSeqNumContext.IITR183) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR182", Value = GetValueOrEmpty(rpphiSeqNumContext.IITR182) });

                        response.Add(processMessage);
                    }
                }
            }
        }
        #endregion // VR.ATO.IITR.210035

        #region VR.ATO.IITR.300005

        /* VR.ATO.IITR.300005
        Where the sum of the taxpayers adjusted taxable income and their spouse's adjusted taxable income is greater than $150,000; and the reportable employer superannuation contributions is greater than 8% of Salary or wages gross income, check reportable employer superannuation contributions.
    
        Legacy Rule Format:
        (^IITR208 + ^IITR237) > 150000 AND ^IITR201 > (^IITR601 * 0.08)

        Technical Business Rule Format:
        (^IITR208 + ^IITR237) > 150000 AND ^IITR201 > (^IITR601 * 0.08)
    
        Data Elements:
    
        ^IITR201 = RP:SuperannuationContribution.EmployerReportable.Amount
    
        ^IITR208 = RP:Income.TaxableAdjusted.Amount
    
        ^IITR237 = RP.SPOUSE:Income.TaxableAdjusted.Amount
    
        ^IITR601 = RP:Income.SalaryOrWages.Amount
        */
        protected void VRATOIITR300005(List<ProcessMessageDocument> response, IITR2021 report)
        {
            ProcessMessageDocument processMessage = null;

            bool assertion = (((report.IITR208.GetValueOrDefault() + report.IITR237.GetValueOrDefault()) > 150000) && (report.IITR201.GetValueOrDefault() > (report.IITR601.GetValueOrDefault() * 0.08m)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.300005",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Check reportable employer superannuation contributions",
                    LongDescription = @"Check that compulsory super contributions have not been included in reportable employer superannuation contributions at the income test section. Some reportable employer superannuation contributions are incorrectly reported on payment summaries, these amounts are generally salary sacrifice super contributions only.",
                    Location = "/xbrli:xbrl/tns:SuperannuationContribution.EmployerReportable.Amount[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.300005" } },
                };

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR208", Value = report.IITR208.GetValueOrDefault().ToString() });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR237", Value = report.IITR237.GetValueOrDefault().ToString() });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR201", Value = report.IITR201.GetValueOrDefault().ToString() });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR601", Value = report.IITR601.GetValueOrDefault().ToString() });

                response.Add(processMessage);
            }
        }

        #endregion // VR.ATO.IITR.300005

        #region VR.ATO.IITR.300013
        protected void VRATOIITR300013(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.300013

        #region VR.ATO.IITR.300039

        /* VR.ATO.IITR.300039
        A loss amount has been entered at primary production business income or non-primary production business income or Net Personal Services Income, but there are no Business loss activity details.
    
        Legacy Rule Format:
        (^IITR281 < 0 OR ^IITR285 < 0 OR ^IITR279 < 0) AND ^IITR479 = BLANK
        
        Technical Business Rule Format:
        (^IITR281 < 0 OR ^IITR285 < 0 OR ^IITR279 < 0) AND ^IITR479 = BLANK
            
        Data Elements:
            
        ^IITR479 = RP.{LOSSSeqNum}:OrganisationDetails.MainIncomeActivity.Description
            
        ^IITR279 = RP:Income.PersonalServicesIncome.Net.Amount
            
        ^IITR281 = RP:Income.PrimaryProductionNet.Amount
            
        ^IITR285 = RP:Income.NonPrimaryProductionNet.Amount
        */
        protected void VRATOIITR300039(List<ProcessMessageDocument> response, IITR2021 report)
        {
            ProcessMessageDocument processMessage;
            bool assertion;

            assertion = ((report.IITR281.GetValueOrDefault() < 0 || report.IITR285.GetValueOrDefault() < 0 || report.IITR279.GetValueOrDefault() < 0) && (report.RPLOSSSeqNumContextCollection != null ? report.RPLOSSSeqNumContextCollection.Exists(context => string.IsNullOrWhiteSpace(context.IITR479) == false) == false : true));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.300039",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"'Business loss activity - Description of activity' is required",
                    LongDescription = @"When either a loss amount for primary production business income, non-primary production business income or Net Personal Services Income has been entered, Business loss activity details must be present",
                    Location = "/xbrli:xbrl/tns:OrganisationDetails.MainIncomeActivity.Description",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.300039" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR281", Value = report.IITR281.GetValueOrDefault().ToString() });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR285", Value = report.IITR285.GetValueOrDefault().ToString() });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR279", Value = report.IITR279.GetValueOrDefault().ToString() });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR479", Value = "null" });

                response.Add(processMessage);
            }
        }
        #endregion // VR.ATO.IITR.300039

        #region VR.ATO.IITR.300040

        /* VR.ATO.IITR.300040
        A loss has been entered at PP distribution from partnerships or non-PP distribution from partnerships and business loss activity details have not been entered.
    
        Legacy Rule Format:
        (^IITR242 < 0 OR ^IITR252 < 0) AND Count(^RP.{LOSSSeqNum}:Context) > 0 AND ^IITR573 = 1 AND ^IITR479 = BLANK
        
        Technical Business Rule Format:
        (^IITR242 < 0 OR ^IITR252 < 0) AND Count(^RP.{LOSSSeqNum}:Context) > 0 AND ^IITR573 = 1 AND ^IITR479 = BLANK
            
        Data Elements:
            
        ^IITR479 = RP.{LOSSSeqNum}:OrganisationDetails.MainIncomeActivity.Description
            
        ^IITR242 = RP:Income.PartnershipPrimaryProductionShare.Amount
            
        ^IITR252 = RP:Income.PartnershipLessForeignIncomeNonPrimaryProductionShare.Amount
            
        ^IITR573 = RP.{LOSSSeqNum}:Report.ItemOrder.Number
        */

        protected void VRATOIITR300040(List<ProcessMessageDocument> response, IITR2021 report)
        {
            ProcessMessageDocument processMessage;
            bool assertion;

            if (report.RPLOSSSeqNumContextCollection != null)
            {
                foreach (IITR2021.RPLOSSSeqNumContext rplossSeqNumContext in report.RPLOSSSeqNumContextCollection)
                {
                    assertion = ((report.IITR242.GetValueOrDefault() < 0 || report.IITR252.GetValueOrDefault() < 0) && rplossSeqNumContext.IITR573 == 1 && string.IsNullOrWhiteSpace(rplossSeqNumContext.IITR479) == true);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.300040",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"'Business loss activity - Description of activity' is required",
                            LongDescription = @"When a loss has been entered at either 'Distribution from partnerships' or 'Distribution from partnerships less foreign income', the 'Business loss activity - Description of activity' must be provided",
                            Location = "/xbrli:xbrl/tns:OrganisationDetails.MainIncomeActivity.Description[@contextRef='" + rplossSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.300040" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR242", Value = GetValueOrEmpty(report.IITR242) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR252", Value = GetValueOrEmpty(report.IITR252) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR573", Value = rplossSeqNumContext.IITR573.ToString() });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR479", Value = GetValueOrEmpty(rplossSeqNumContext.IITR479) });

                        response.Add(processMessage);
                    }
                }
            }
        }
        #endregion // VR.ATO.IITR.300040

        #region VR.ATO.IITR.300087

        protected void VRATOIITR300087(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.300087

        #region VR.ATO.IITR.300094
        protected void VRATOIITR300094(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.300094

        #region VR.ATO.IITR.310027

        /* VR.ATO.IITR.310027
        The answer to "Satisfied the results test" is No, and no answer has been provided to the "Received a personal services business determination(s) for the whole of the period PSI earned" question.
    
        Legacy Rule Format:
        (^IITR406 = NULL) AND (^IITR404 = TRUE) AND (^IITR405 = FALSE)

        Technical Business Rule Format:
        (^IITR406 = NULL) AND (^IITR404 = TRUE) AND (^IITR405 = FALSE)
    
        Data Elements:
    
        ^IITR406 = RP:IncomeTax.PersonalServicesIncome.IndividualPersonalServiceBusinessDeterminationHeld.Indicator
    
        ^IITR404 = RP:Income.PersonalServicesIncomeIncluded.Indicator
    
        ^IITR405 = RP:IncomeTax.PersonalServicesIncome.IndividualResultsTestSatisfied.Indicator
        */
        protected void VRATOIITR310027(List<ProcessMessageDocument> response, IITR2021 report)
        {
            ProcessMessageDocument processMessage;
            bool assertion;

            assertion = (report.IITR406 == null && report.IITR404 == true && report.IITR405 == false);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310027",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"'Received a personal services business determination(s)...' must be provided",
                    LongDescription = @"Where the answer to the question 'Received personal services income' is 'yes' (true), and the answer to the question 'Satisfied the results test' is 'no' (false), the question 'Received a personal services business determination(s) for the whole of the period PSI earned' must be answered",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PersonalServicesIncome.IndividualPersonalServiceBusinessDeterminationHeld.Indicator",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310027" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR406", Value = GetValueOrEmpty(report.IITR406) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR404", Value = GetValueOrEmpty(report.IITR404) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR405", Value = GetValueOrEmpty(report.IITR405) });

                response.Add(processMessage);
            }
        }
        #endregion // VR.ATO.IITR.310027

        #region VR.ATO.IITR.400063

        /* VR.ATO.IITR.400063
        The Sequence Container within the Reporting Party Loss context must be assigned sequentially beginning at 1 and must not exceed 10
    
        Legacy Rule Format:
        ((^IITR573 < 1 OR ^IITR573 > 10)) OR (^IITR573 > Count(^RP.{LOSSSeqNum}:Context))
        
        Technical Business Rule Format:
        ((^IITR573 < 1 OR ^IITR573 > 10)) OR (^IITR573 > Count(^RP.{LOSSSeqNum}:Context))
            
        Data Elements:
            
        ^IITR573 = RP.{LOSSSeqNum}:Report.ItemOrder.Number
        */
        protected void VRATOIITR400063(List<ProcessMessageDocument> response, IITR2021 report)
        {
            ProcessMessageDocument processMessage;
            bool assertion;
            if (report.RPLOSSSeqNumContextCollection != null)
            {
                foreach (IITR2021.RPLOSSSeqNumContext rplossSeqNumContext in report.RPLOSSSeqNumContextCollection)
                {
                    assertion = (!(IsMatch(Convert.ToInt32(rplossSeqNumContext.IITR573), @"^([1-9]|10)$", RegexOptions.IgnoreCase)) || Convert.ToInt32(rplossSeqNumContext.IITR573) > Count(report.RPLOSSSeqNumContextCollection));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.401063",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"The Sequence Container within the Reporting Party Loss context is incorrect",
                            LongDescription = @"The Sequence Container within the Reporting Party Loss context must be assigned sequentially beginning at 1 and must not exceed 10",
                            Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPLOSSSeqNumContextCollection == null ? 0 : (report.RPLOSSSeqNumContextCollection.Count() == 0 ? 0 : report.RPLOSSSeqNumContextCollection.Last().LastOccurrenceIndex)),
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400063" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR573", Value = rplossSeqNumContext.IITR573.ToString() });

                        response.Add(processMessage);
                    }
                }
            }
        }
        #endregion // VR.ATO.IITR.400063

        #region VR.ATO.IITR.410018

        /* VR.ATO.IITR.410018
        Primary production deferred losses and/or non-primary production deferred losses have been entered without Business loss activity details being completed.
    
        Legacy Rule Format:
        (^IITR299 + ^IITR300) > 0 AND (Count(^RP.{LOSSSeqNum}:Context) = 0 OR AllOccurrences(^IITR479, ^IITR479 = BLANK))

        Technical Business Rule Format:
        (^IITR299 + ^IITR300) > 0 AND (Count(^RP.{LOSSSeqNum}:Context) = 0 OR AllOccurrences(^IITR479, ^IITR479 = BLANK))
    
        Data Elements:
    
        ^IITR479 = RP.{LOSSSeqNum}:OrganisationDetails.MainIncomeActivity.Description
    
        ^IITR299 = RP:Tax.Losses.DeferredNonCommercialPrimaryProduction.Amount
    
        ^IITR300 = RP:Tax.Losses.DeferredNonCommercialNonPrimaryProduction.Amount
        */
        protected void VRATOIITR410018(List<ProcessMessageDocument> response, IITR2021 report)
        {
            ProcessMessageDocument processMessage;
            bool assertion;

            assertion = (report.IITR299.GetValueOrDefault() + report.IITR300.GetValueOrDefault() > 0 && (report.RPLOSSSeqNumContextCollection != null ? Count(report.RPLOSSSeqNumContextCollection) == 0 || report.RPLOSSSeqNumContextCollection.Exists(context => string.IsNullOrWhiteSpace(context.IITR479) == false) == false : true));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410018",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Business loss activity details is required",
                    LongDescription = @"Primary production deferred losses and/or non-primary production deferred losses have been entered without Business loss activity details being completed",
                    Location = "/xbrli:xbrl/tns:OrganisationDetails.MainIncomeActivity.Description",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410018" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR299", Value = report.IITR299.GetValueOrDefault().ToString() });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR300", Value = report.IITR300.GetValueOrDefault().ToString() });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR479", Value = "null" });

                response.Add(processMessage);
            }
        }
        #endregion // VR.ATO.IITR.410018

        #region VR.ATO.IITR.410034

        /* VR.ATO.IITR.410034
        For income test purposes, spouse's adjusted taxable income (ATI) is the sum of spouse's taxable income, spouse's adjusted fringe benefit (Your spouse's total reportable fringe benefits amount from employers exempt under section 57A x 0.530 plus Your spouse's total reportable fringe benefits amounts from employers not exempt under section 57A), spouse's target foreign income, spouse's tax-free pensions (exempt pensions plus tax-free pensions paid under Military Rehabilitation and Compensation Act), spouse's total net investment loss, spouse's reportable superannuation contributions less child support the spouse paid. For the benefit of other calculations, ensure the ATI amount is correct.
    
        Legacy Rule Format:
        ^IITR223 <> TRUE AND ((^IITR237 = NULL AND OutsideRange(0, (^IITR225 + ConditionalValue((^IITR492 + ^IITR493) > 3772, ((^IITR492 * 0.530) + ^IITR493), 0) + ^IITR233 + ^IITR230 + ^IITR232 + ^IITR234 + ^IITR231 - ^IITR235), 1)) OR (^IITR237 <> NULL AND OutsideRange(^IITR237, (^IITR225 + ConditionalValue((^IITR492 + ^IITR493) > 3772, ((^IITR492 * 0.530) + ^IITR493), 0) + ^IITR233 + ^IITR230 + ^IITR232 + ^IITR234 + ^IITR231 - ^IITR235), 1)))

        Technical Business Rule Format:
        ^IITR223 <> TRUE AND ((^IITR237 = NULL AND OutsideRange(0, (^IITR225 + ConditionalValue((^IITR492 + ^IITR493) > 3772, ((^IITR492 * 0.530) + ^IITR493), 0) + ^IITR233 + ^IITR230 + ^IITR232 + ^IITR234 + ^IITR231 - ^IITR235), 1)) OR (^IITR237 <> NULL AND OutsideRange(^IITR237, (^IITR225 + ConditionalValue((^IITR492 + ^IITR493) > 3772, ((^IITR492 * 0.530) + ^IITR493), 0) + ^IITR233 + ^IITR230 + ^IITR232 + ^IITR234 + ^IITR231 - ^IITR235), 1)))
    
        Data Elements:
    
        ^IITR223 = RP.SPOUSE:PersonDemographicDetails.Deceased.Indicator
    
        ^IITR225 = RP.SPOUSE:Income.Taxable.Amount
    
        ^IITR230 = RP.SPOUSE:Pension.SpouseExempt.Amount
    
        ^IITR231 = RP.SPOUSE:SuperannuationContribution.EmployerReportable.Amount
    
        ^IITR232 = RP.SPOUSE:Pension.TaxFree.Amount
    
        ^IITR233 = RP.SPOUSE:InternationalDealings.ForeignIncomeTarget.Amount
    
        ^IITR234 = RP.SPOUSE:Tax.Losses.InvestmentNet.Amount
    
        ^IITR235 = RP.SPOUSE:ChildSupport.Payment.Amount
    
        ^IITR237 = RP.SPOUSE:Income.TaxableAdjusted.Amount
    
        ^IITR492 = RP.SPOUSE.Eligible:Income.FringeBenefitsReportable.Amount
    
        ^IITR493 = RP.SPOUSE.Ineligible:Income.FringeBenefitsReportable.Amount
        */
        protected void VRATOIITR410034(List<ProcessMessageDocument> response, IITR2021 report)
        {
            ProcessMessageDocument processMessage;
            bool assertion;

            assertion = (report.IITR223 != true && (report.IITR237 == null && OutsideRange(0, report.IITR225.GetValueOrDefault() + ConditionalValue(report.IITR492.GetValueOrDefault() + report.IITR493.GetValueOrDefault() > 3772, (report.IITR492.GetValueOrDefault() * 0.530M) + report.IITR493.GetValueOrDefault(), 0) + report.IITR233.GetValueOrDefault() + report.IITR230.GetValueOrDefault() + report.IITR232.GetValueOrDefault() + report.IITR234.GetValueOrDefault() + report.IITR231.GetValueOrDefault() - report.IITR235.GetValueOrDefault(), 1) || report.IITR237 != null && OutsideRange(report.IITR237.GetValueOrDefault(), report.IITR225.GetValueOrDefault() + ConditionalValue(report.IITR492.GetValueOrDefault() + report.IITR493.GetValueOrDefault() > 3772, (report.IITR492.GetValueOrDefault() * 0.530M) + report.IITR493.GetValueOrDefault(), 0) + report.IITR233.GetValueOrDefault() + report.IITR230.GetValueOrDefault() + report.IITR232.GetValueOrDefault() + report.IITR234.GetValueOrDefault() + report.IITR231.GetValueOrDefault() - report.IITR235.GetValueOrDefault(), 1)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.022013",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's ATI amount for Income test purposes is incorrect",
                    LongDescription = @"For income test purposes, spouse's adjusted taxable income (ATI) is the sum of spouse's taxable income, spouse's adjusted fringe benefit (Your spouse's total reportable fringe benefits amount from employers exempt under section 57A x 0.530 plus Your spouse's total reportable fringe benefits amounts from employers not exempt under section 57A), spouse's target foreign income, spouse's tax-free pensions (exempt pensions plus tax-free pensions paid under Military Rehabilitation and Compensation Act), spouse's total net investment loss, spouse's reportable superannuation contributions less child support the spouse paid. For the benefit of other calculations, ensure the ATI amount is correct.",
                    Location = "/xbrli:xbrl/tns:PersonDemographicDetails.Deceased.Indicator[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410034" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR223", Value = report.IITR223.GetValueOrDefault().ToString() });
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR225", Value = report.IITR225.GetValueOrDefault().ToString() });
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR230", Value = report.IITR230.GetValueOrDefault().ToString() });
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR231", Value = report.IITR231.GetValueOrDefault().ToString() });
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR232", Value = report.IITR232.GetValueOrDefault().ToString() });
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR233", Value = report.IITR233.GetValueOrDefault().ToString() });
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR234", Value = report.IITR234.GetValueOrDefault().ToString() });
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR235", Value = report.IITR235.GetValueOrDefault().ToString() });
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR237", Value = report.IITR237.GetValueOrDefault().ToString() });
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR492", Value = report.IITR492.GetValueOrDefault().ToString() });
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR493", Value = report.IITR493.GetValueOrDefault().ToString() });

                response.Add(processMessage);
            }
        }
        #endregion // VR.ATO.IITR.410034

        #region VR.ATO.IITR.410068

        /* VR.ATO.IITR.410068
        Business loss activity - Partnership or sole trader codes are: '161' - Partnerships; '006' - Sole Trader.
    
        Legacy Rule Format:
        ^IITR481 <> NULL AND NotInSet(^IITR481, '"006", "161"')
        
        Technical Business Rule Format:
        ^IITR481 <> NULL AND NotInSet(^IITR481, '"006", "161"')
            
        Data Elements:
            
        ^IITR481 = RP.{LOSSSeqNum}:OrganisationDetails.OrganisationType.Code
        */
        protected void VRATOIITR410068(List<ProcessMessageDocument> response, IITR2021 report)
        {
            ProcessMessageDocument processMessage;
            bool assertion;

            if (report.RPLOSSSeqNumContextCollection != null)
            {
                foreach (IITR2021.RPLOSSSeqNumContext rplossSeqNumContext in report.RPLOSSSeqNumContextCollection)
                {
                    assertion = (rplossSeqNumContext.IITR481 != null && !(IsMatch(rplossSeqNumContext.IITR481, @"^(006|161)$", RegexOptions.IgnoreCase)));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.410068",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"'Business loss activity - Partnership or sole trader' details incorrect",
                            LongDescription = @"Valid Business loss activity - '161' (partnership) or '006' (sole trader)",
                            Location = "/xbrli:xbrl/tns:OrganisationDetails.OrganisationType.Code[@contextRef='" + rplossSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410068" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR481", Value = GetValueOrEmpty(rplossSeqNumContext.IITR481) });

                        response.Add(processMessage);
                    }
                }
            }
        }
        #endregion // VR.ATO.IITR.410068

        #region VR.ATO.IITR.410083

        /* VR.ATO.IITR.410083
        Distributions to your spouse on which family trust distribution tax has been paid has a maximum field length of 11
    
        Legacy Rule Format:
        NotMonetary(^IITR227, 'U', 11, 0)

        Technical Business Rule Format:
        NotMonetary(^IITR227, 'U', 11, 0)
    
        Data Elements:
    
        ^IITR227 = RP.SPOUSE:IncomeTax.FamilyTrustDistributionWhereTaxPaid.Amount
        */
        protected void VRATOIITR410083(List<ProcessMessageDocument> response, IITR2021 report)
        {
            ProcessMessageDocument processMessage;
            bool assertion;

            assertion = NotMonetary(report.IITR227, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410083",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"'Distributions to your spouse on which family trust distribution...' is not in a valid monetary format",
                    LongDescription = @"Distributions to your spouse on which family trust distribution tax has been paid must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.FamilyTrustDistributionWhereTaxPaid.Amount[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410083" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR227", Value = GetValueOrEmpty(report.IITR227) });

                response.Add(processMessage);
            }
        }
        #endregion // VR.ATO.IITR.410083

        #region VR.ATO.IITR.410085

        /* VR.ATO.IITR.410085
        Amount of any Australian Government pensions and allowances received by your spouse in the year of the return has a maximum field length of 11
    
        Legacy Rule Format:
        NotMonetary(^IITR229, 'U', 11, 0)

        Technical Business Rule Format:
        NotMonetary(^IITR229, 'U', 11, 0)
    
        Data Elements:
    
        ^IITR229 = RP.SPOUSE:Pension.Total.Amount
        */
        protected void VRATOIITR410085(List<ProcessMessageDocument> response, IITR2021 report)
        {
            ProcessMessageDocument processMessage;
            bool assertion;

            assertion = NotMonetary(report.IITR229, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410085",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"'Amount of any Australian Government pensions and allowances...' is not in a valid monetary format",
                    LongDescription = @"Amount of any Australian Government pensions and allowances received by your spouse in the year of the return must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Pension.Total.Amount[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410085" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR229", Value = GetValueOrEmpty(report.IITR229) });

                response.Add(processMessage);
            }
        }
        #endregion // VR.ATO.IITR.410085

        #region VR.ATO.IITR.410086

        /* VR.ATO.IITR.410086
        Amount of any exempt pension income received by your spouse in the year of the return has a maximum field length of 11
    
        Legacy Rule Format:
        NotMonetary(^IITR230, 'U', 11, 0)

        Technical Business Rule Format:
        NotMonetary(^IITR230, 'U', 11, 0)
    
        Data Elements:
    
        ^IITR230 = RP.SPOUSE:Pension.SpouseExempt.Amount
        */
        protected void VRATOIITR410086(List<ProcessMessageDocument> response, IITR2021 report)
        {
            ProcessMessageDocument processMessage;
            bool assertion;

            assertion = NotMonetary(report.IITR230, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410086",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"'Amount of any exempt pension income received by your spouse...' is not in a valid monetary format",
                    LongDescription = @"Amount of any exempt pension income received by your spouse in the year of the return must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Pension.SpouseExempt.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410086" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR230", Value = GetValueOrEmpty(report.IITR230) });

                response.Add(processMessage);
            }
        }
        #endregion // VR.ATO.IITR.410086

        #region VR.ATO.IITR.410116

        /* VR.ATO.IITR.410116
        Small business entity simplified depreciation - Deduction for certain assets has a maximum field length of 11
    
        Legacy Rule Format:
        NotMonetary(^IITR507, 'U', 11, 0)

        Technical Business Rule Format:
        NotMonetary(^IITR507, 'U', 11, 0)
    
        Data Elements:
    
        ^IITR507 = RP:IncomeTax.Deduction.LowCostAssetDepreciation.Amount
        */
        protected void VRATOIITR410116(List<ProcessMessageDocument> response, IITR2021 report)
        {
            ProcessMessageDocument processMessage;
            bool assertion;

            assertion = NotMonetary(report.IITR507, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410116",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"'Small business entity... - Deduction for certain assets' is not in a valid monetary format",
                    LongDescription = @"Small business entity simplified depreciation - Deduction for certain assets must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.LowCostAssetDepreciation.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410116" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR507", Value = GetValueOrEmpty(report.IITR507) });

                response.Add(processMessage);
            }
        }
        #endregion // VR.ATO.IITR.410116

        #region VR.ATO.IITR.410117

        /* VR.ATO.IITR.410117
        Small business entity simplified depreciation - Deduction for general small business pool has a maximum field length of 11
    
        Legacy Rule Format:
        NotMonetary(^IITR508, 'U', 11, 0)

        Technical Business Rule Format:
        NotMonetary(^IITR508, 'U', 11, 0)
    
        Data Elements:
    
        ^IITR508 = RP:IncomeTax.Deduction.SmallBusinessPoolDepreciation.Amount
        */
        protected void VRATOIITR410117(List<ProcessMessageDocument> response, IITR2021 report)
        {
            ProcessMessageDocument processMessage;
            bool assertion;

            assertion = NotMonetary(report.IITR508, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410117",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"'Small business entity... - Deduction for general small business pool' is not in a valid monetary format",
                    LongDescription = @"Small business entity simplified depreciation - Deduction for general small business pool must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.SmallBusinessPoolDepreciation.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410117" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR508", Value = GetValueOrEmpty(report.IITR508) });

                response.Add(processMessage);
            }
        }
        #endregion // VR.ATO.IITR.410117

        #region VR.ATO.IITR.600051

        /* VR.ATO.IITR.600051
        Work related uniform, occupation specific or protective clothing, laundry and dry cleaning expenses has a maximum field length of 11
    
        Legacy Rule Format:
        NotMonetary(^IITR137, 'U', 11, 0)

        Technical Business Rule Format:
        NotMonetary(^IITR137, 'U', 11, 0)
    
        Data Elements:
    
        ^IITR137 = RP:IncomeTax.Deduction.Clothing.Amount
        */
        protected void VRATOIITR600051(List<ProcessMessageDocument> response, IITR2021 report)
        {
            ProcessMessageDocument processMessage;
            bool assertion;

            assertion = NotMonetary(report.IITR137, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600051",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"'Work related uniform,... and dry cleaning expenses' is not in a valid monetary format",
                    LongDescription = @"Work related uniform, occupation specific or protective clothing, laundry and dry cleaning expenses must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.Clothing.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600051" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR137", Value = GetValueOrEmpty(report.IITR137) });

                response.Add(processMessage);
            }
        }
        #endregion // VR.ATO.IITR.600051

        #region VR.ATO.IITR.730108
        protected void VRATOIITR730108(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730108

        #region VR.ATO.IITR.730303
        protected void VRATOIITR730303(List<ProcessMessageDocument> response, IITR2021 report)
        {
            //Removed due to being a crossform rule
        }
        #endregion // VR.ATO.IITR.730303

        #region VR.ATO.IITR.000263

        /* VR.ATO.IITR.000263
        The total of all income fields does not equal the amount at the Total income or loss field.
    
        Legacy Rule Format:
        ((^IITR131 <> NULL) AND OutsideRange(^IITR131, (^IITR86 + ^IITR89 + ^IITR601 + ^IITR607 + (^IITR609*0.05) + ^IITR626 + ^IITR65 + ^IITR92 + ^IITR93 + ^IITR505 + ^IITR94 + ^IITR95 + ^IITR611 + ^IITR612 + ^IITR112 + ^IITR115 + ^IITR118 + ^IITR119 + ^IITR120 + ^IITR127 + ^IITR242 + ^IITR243 - ^IITR245 - ^IITR246 + ^IITR252 + ^IITR255 + ^IITR259 - ^IITR260 - ^IITR265 + ^IITR279 + ^IITR281 + ^IITR285 + ^IITR299 + ^IITR300 + ^IITR306 + ^IITR311 + ^IITR316 + ^IITR318 + ^IITR321 + ^IITR322 + ^IITR323 + ^IITR324 + ^IITR327 + ^IITR328 + ^IITR334 - ^IITR335 - ^IITR336 - ^IITR337 + ^IITR339 + ^IITR341 + ^IITR615 + ^IITR616 + ^IITR650 + ^IITR618), 1)) OR ((^IITR131 = NULL) AND OutsideRange(0, (^IITR86 + ^IITR89 + ^IITR601 + ^IITR607 + (^IITR609*0.05) + ^IITR626 + ^IITR65 + ^IITR92 + ^IITR93 + ^IITR505 + ^IITR94 + ^IITR95 + ^IITR611 + ^IITR612 + ^IITR112 + ^IITR115 + ^IITR118 + ^IITR119 + ^IITR120 + ^IITR127 + ^IITR242 + ^IITR243 - ^IITR245 - ^IITR246 + ^IITR252 + ^IITR255 + ^IITR259 - ^IITR260 - ^IITR265 + ^IITR279 + ^IITR281 + ^IITR285 + ^IITR299 + ^IITR300 + ^IITR306 + ^IITR311 + ^IITR316 + ^IITR318 + ^IITR321 + ^IITR322 + ^IITR323 + ^IITR324 + ^IITR327 + ^IITR328 + ^IITR334 - ^IITR335 - ^IITR336 - ^IITR337 + ^IITR339 + ^IITR341 + ^IITR615 + ^IITR616 + ^IITR650 + ^IITR618), 1))

        Technical Business Rule Format:
        ((^IITR131 <> NULL) AND OutsideRange(^IITR131, (^IITR86 + ^IITR89 + ^IITR601 + ^IITR607 + (^IITR609*0.05) + ^IITR626 + ^IITR65 + ^IITR92 + ^IITR93 + ^IITR505 + ^IITR94 + ^IITR95 + ^IITR611 + ^IITR612 + ^IITR112 + ^IITR115 + ^IITR118 + ^IITR119 + ^IITR120 + ^IITR127 + ^IITR242 + ^IITR243 - ^IITR245 - ^IITR246 + ^IITR252 + ^IITR255 + ^IITR259 - ^IITR260 - ^IITR265 + ^IITR279 + ^IITR281 + ^IITR285 + ^IITR299 + ^IITR300 + ^IITR306 + ^IITR311 + ^IITR316 + ^IITR318 + ^IITR321 + ^IITR322 + ^IITR323 + ^IITR324 + ^IITR327 + ^IITR328 + ^IITR334 - ^IITR335 - ^IITR336 - ^IITR337 + ^IITR339 + ^IITR341 + ^IITR615 + ^IITR616 + ^IITR650 + ^IITR618), 1)) OR ((^IITR131 = NULL) AND OutsideRange(0, (^IITR86 + ^IITR89 + ^IITR601 + ^IITR607 + (^IITR609*0.05) + ^IITR626 + ^IITR65 + ^IITR92 + ^IITR93 + ^IITR505 + ^IITR94 + ^IITR95 + ^IITR611 + ^IITR612 + ^IITR112 + ^IITR115 + ^IITR118 + ^IITR119 + ^IITR120 + ^IITR127 + ^IITR242 + ^IITR243 - ^IITR245 - ^IITR246 + ^IITR252 + ^IITR255 + ^IITR259 - ^IITR260 - ^IITR265 + ^IITR279 + ^IITR281 + ^IITR285 + ^IITR299 + ^IITR300 + ^IITR306 + ^IITR311 + ^IITR316 + ^IITR318 + ^IITR321 + ^IITR322 + ^IITR323 + ^IITR324 + ^IITR327 + ^IITR328 + ^IITR334 - ^IITR335 - ^IITR336 - ^IITR337 + ^IITR339 + ^IITR341 + ^IITR615 + ^IITR616 + ^IITR650 + ^IITR618), 1))
    
        Data Elements:
    
        ^IITR131 = RP:Income.Net.Amount
    
        ^IITR65 = RP:Income.AllowancesEarningsTipsDirectorsFees.Amount
    
        ^IITR86 = RP:Income.AustralianGovernmentAllowancesAndPayments.Amount
    
        ^IITR89 = RP:Pension.Total.Amount
    
        ^IITR92 = RP:Income.Superannuation.AnnuitiesAndSuperannuationTaxableComponentTaxedElement.Amount
    
        ^IITR93 = RP:Income.Superannuation.AnnuitiesAndSuperannuationTaxableComponentUntaxedElement.Amount
    
        ^IITR94 = RP:Income.Superannuation.AnnuitiesAndSuperannuationLumpSumArrearsTaxableComponentTaxedElement.Amount
    
        ^IITR95 = RP:Income.Superannuation.AnnuitiesAndSuperannuationLumpSumArrearsTaxableComponentUntaxedElement.Amount
    
        ^IITR112 = RP:Income.PersonalServicesIncome.Total.Amount
    
        ^IITR115 = RP:Income.Interest.Gross.Amount
    
        ^IITR118 = RP:Income.DividendsUnfranked.Amount
    
        ^IITR119 = RP:Income.DividendsFranked.Amount
    
        ^IITR120 = RP:IncomeTax.FrankingCredits.Amount
    
        ^IITR127 = RP:Income.EmployeeShareScheme.DiscountAssessable.Amount
    
        ^IITR242 = RP:Income.PartnershipPrimaryProductionShare.Amount
    
        ^IITR243 = RP:Income.TrustPrimaryProductionNetShare.Amount
    
        ^IITR245 = RP.Partnership:Expense.LandcareOperationsAcceleratedDepreciation.Amount
    
        ^IITR246 = RP:IncomeTax.Deduction.PartnershipsAndTrustPrimaryProductionShare.Amount
    
        ^IITR252 = RP:Income.PartnershipLessForeignIncomeNonPrimaryProductionShare.Amount
    
        ^IITR255 = RP:Income.TrustLessNetCapitalGainAndForeignIncomeNonPrimaryProductionShare.Amount
    
        ^IITR259 = RP:Income.TrustFrankedNonPrimaryProductionShare.Amount
    
        ^IITR260 = RP:Expense.LandcareOperationsNonPrimaryProduction.Amount
    
        ^IITR265 = RP:IncomeTax.Deduction.TrustPartnershipOtherNonPrimaryProductionNet.Amount
    
        ^IITR279 = RP:Income.PersonalServicesIncome.Net.Amount
    
        ^IITR281 = RP:Income.PrimaryProductionNet.Amount
    
        ^IITR285 = RP:Income.NonPrimaryProductionNet.Amount
    
        ^IITR299 = RP:Tax.Losses.DeferredNonCommercialPrimaryProduction.Amount
    
        ^IITR300 = RP:Tax.Losses.DeferredNonCommercialNonPrimaryProduction.Amount
    
        ^IITR306 = RP:Income.FarmManagementDepositsOrRepaymentsNet.Amount
    
        ^IITR311 = RP:Capital.Gains.Net.Amount
    
        ^IITR316 = RP:Income.ControlledForeignCompaniesAttributableIncome.Amount
    
        ^IITR318 = RP:InternationalDealings.TransferorTrustAttributedForeignIncome.Amount
    
        ^IITR321 = RP:InternationalDealings.ForeignEmploymentIncomeOther.Amount
    
        ^IITR322 = RP:InternationalDealings.ForeignPensionOrAnnuityIncomeWithoutUndeductedPurchasePrice.Amount
    
        ^IITR323 = RP:InternationalDealings.ForeignPensionOrAnnuityIncomeUndeductedPurchasePrice.Amount
    
        ^IITR324 = RP:InternationalDealings.ForeignRent.Amount
    
        ^IITR327 = RP:Income.InternationalDealings.Net.Amount
    
        ^IITR328 = RP:IncomeTax.FrankingCreditsNewZealand.Amount
    
        ^IITR334 = RP:Income.RealEstateProperty.Rental.Amount
    
        ^IITR335 = RP:IncomeTax.Deduction.RentalIncomeInterestDeductions.Amount
    
        ^IITR336 = RP:IncomeTax.Deduction.CapitalWorksDeductions.Amount
    
        ^IITR337 = RP:IncomeTax.Deduction.RentalIncomeDeductionsOtherThanInterestAndCapitalWorks.Amount
    
        ^IITR339 = RP:IncomeTax.LifeInsuranceCompaniesAndFriendlySocietiesBonuses.Amount
    
        ^IITR341 = RP:Income.ForestryManagedInvestmentScheme.Amount
    
        ^IITR505 = RP:Income.Superannuation.AnnuitiesAndSuperannuationAssessableCappedBenefit.Amount
    
        ^IITR601 = RP:Income.SalaryOrWages.Amount
    
        ^IITR607 = RP:Income.UnusedAnnualOrLongServiceLeavePaymentLumpSumA.Amount
    
        ^IITR609 = RP:Income.UnusedAnnualOrLongServiceLeavePaymentLumpSumB.Amount
    
        ^IITR611 = RP:Income.Superannuation.LumpSumPaymentTaxableComponentTaxedElement.Amount
    
        ^IITR612 = RP:Income.Superannuation.LumpSumPaymentTaxableComponentUntaxedElement.Amount
    
        ^IITR615 = RP:IncomeTax.IncomeCategory1Other.Amount
    
        ^IITR616 = RP:IncomeTax.IncomeCategory2Total.Amount
    
        ^IITR618 = RP:IncomeTax.IncomeCategoryMiscellaneousOther.Amount
    
        ^IITR626 = RP:Income.EmploymentTerminationPaymentTaxable.Amount
    
        ^IITR650 = RP:IncomeTax.AssessableFirstHomeSuperSaverReleased.Amount
        */
        protected void VRATOIITR000263(List<ProcessMessageDocument> response, IITR2021 report)
        {
            ProcessMessageDocument processMessage;
            bool assertion;

            decimal totalofIncomeFields = report.IITR86.GetValueOrDefault() + report.IITR89.GetValueOrDefault() + report.IITR601.GetValueOrDefault() + report.IITR607.GetValueOrDefault() + report.IITR609.GetValueOrDefault() * 0.05M + report.IITR626.GetValueOrDefault() + report.IITR65.GetValueOrDefault() + report.IITR92.GetValueOrDefault() + report.IITR93.GetValueOrDefault() + report.IITR505.GetValueOrDefault() + report.IITR94.GetValueOrDefault() + report.IITR95.GetValueOrDefault() + report.IITR611.GetValueOrDefault() + report.IITR612.GetValueOrDefault() + report.IITR112.GetValueOrDefault() + report.IITR115.GetValueOrDefault() + report.IITR118.GetValueOrDefault() + report.IITR119.GetValueOrDefault() + report.IITR120.GetValueOrDefault() + report.IITR127.GetValueOrDefault() + report.IITR242.GetValueOrDefault() + report.IITR243.GetValueOrDefault() - report.IITR245.GetValueOrDefault() - report.IITR246.GetValueOrDefault() + report.IITR252.GetValueOrDefault() + report.IITR255.GetValueOrDefault() + report.IITR259.GetValueOrDefault() - report.IITR260.GetValueOrDefault() - report.IITR265.GetValueOrDefault() + report.IITR279.GetValueOrDefault() + report.IITR281.GetValueOrDefault() + report.IITR285.GetValueOrDefault() + report.IITR299.GetValueOrDefault() + report.IITR300.GetValueOrDefault() + report.IITR306.GetValueOrDefault() + report.IITR311.GetValueOrDefault() + report.IITR316.GetValueOrDefault() + report.IITR318.GetValueOrDefault() + report.IITR321.GetValueOrDefault() + report.IITR322.GetValueOrDefault() + report.IITR323.GetValueOrDefault() + report.IITR324.GetValueOrDefault() + report.IITR327.GetValueOrDefault() + report.IITR328.GetValueOrDefault() + report.IITR334.GetValueOrDefault() - report.IITR335.GetValueOrDefault() - report.IITR336.GetValueOrDefault() - report.IITR337.GetValueOrDefault() + report.IITR339.GetValueOrDefault() + report.IITR341.GetValueOrDefault() + report.IITR615.GetValueOrDefault() + report.IITR616.GetValueOrDefault() + report.IITR650.GetValueOrDefault() + report.IITR618.GetValueOrDefault();

            assertion = (report.IITR131 != null && OutsideRange(report.IITR131.GetValueOrDefault(), totalofIncomeFields, 1) || report.IITR131 == null && OutsideRange(0, totalofIncomeFields, 1));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000263",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Total income or loss field is incorrect",
                    LongDescription = @"The total of all income fields does not equal the amount at the Total income or loss field",
                    Location = "/xbrli:xbrl/tns:Income.Net.Amount[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000263" },
                    new ProcessMessageParameter { Name = "IITR131", Value = GetValueOrEmpty(report.IITR131) },
                    new ProcessMessageParameter { Name = "Calculated total of all income fields", Value = GetValueOrEmpty(totalofIncomeFields) },
                    new ProcessMessageParameter { Name = "IITR86", Value = GetValueOrEmpty(report.IITR86) },
                    new ProcessMessageParameter { Name = "IITR89", Value = GetValueOrEmpty(report.IITR89) },
                    new ProcessMessageParameter { Name = "IITR601", Value = GetValueOrEmpty(report.IITR601) },
                    new ProcessMessageParameter { Name = "IITR607", Value = GetValueOrEmpty(report.IITR607) },
                    new ProcessMessageParameter { Name = "IITR609", Value = GetValueOrEmpty(report.IITR609) },
                    new ProcessMessageParameter { Name = "IITR626", Value = GetValueOrEmpty(report.IITR626) },
                    new ProcessMessageParameter { Name = "IITR65", Value = GetValueOrEmpty(report.IITR65) },
                    new ProcessMessageParameter { Name = "IITR92", Value = GetValueOrEmpty(report.IITR92) },
                    new ProcessMessageParameter { Name = "IITR93", Value = GetValueOrEmpty(report.IITR93) },
                    new ProcessMessageParameter { Name = "IITR505", Value = GetValueOrEmpty(report.IITR505) },
                    new ProcessMessageParameter { Name = "IITR94", Value = GetValueOrEmpty(report.IITR94) },
                    new ProcessMessageParameter { Name = "IITR95", Value = GetValueOrEmpty(report.IITR95) },
                    new ProcessMessageParameter { Name = "IITR611", Value = GetValueOrEmpty(report.IITR611) },
                    new ProcessMessageParameter { Name = "IITR612", Value = GetValueOrEmpty(report.IITR612) },
                    new ProcessMessageParameter { Name = "IITR112", Value = GetValueOrEmpty(report.IITR112) },
                    new ProcessMessageParameter { Name = "IITR115", Value = GetValueOrEmpty(report.IITR115) },
                    new ProcessMessageParameter { Name = "IITR118", Value = GetValueOrEmpty(report.IITR118) },
                    new ProcessMessageParameter { Name = "IITR119", Value = GetValueOrEmpty(report.IITR119) },
                    new ProcessMessageParameter { Name = "IITR120", Value = GetValueOrEmpty(report.IITR120) },
                    new ProcessMessageParameter { Name = "IITR127", Value = GetValueOrEmpty(report.IITR127) },
                    new ProcessMessageParameter { Name = "IITR242", Value = GetValueOrEmpty(report.IITR242) },
                    new ProcessMessageParameter { Name = "IITR243", Value = GetValueOrEmpty(report.IITR243) },
                    new ProcessMessageParameter { Name = "IITR245", Value = GetValueOrEmpty(report.IITR245) },
                    new ProcessMessageParameter { Name = "IITR246", Value = GetValueOrEmpty(report.IITR246) },
                    new ProcessMessageParameter { Name = "IITR252", Value = GetValueOrEmpty(report.IITR252) },
                    new ProcessMessageParameter { Name = "IITR255", Value = GetValueOrEmpty(report.IITR255) },
                    new ProcessMessageParameter { Name = "IITR259", Value = GetValueOrEmpty(report.IITR259) },
                    new ProcessMessageParameter { Name = "IITR260", Value = GetValueOrEmpty(report.IITR260) },
                    new ProcessMessageParameter { Name = "IITR265", Value = GetValueOrEmpty(report.IITR265) },
                    new ProcessMessageParameter { Name = "IITR279", Value = GetValueOrEmpty(report.IITR279) },
                    new ProcessMessageParameter { Name = "IITR281", Value = GetValueOrEmpty(report.IITR281) },
                    new ProcessMessageParameter { Name = "IITR285", Value = GetValueOrEmpty(report.IITR285) },
                    new ProcessMessageParameter { Name = "IITR299", Value = GetValueOrEmpty(report.IITR299) },
                    new ProcessMessageParameter { Name = "IITR300", Value = GetValueOrEmpty(report.IITR300) },
                    new ProcessMessageParameter { Name = "IITR306", Value = GetValueOrEmpty(report.IITR306) },
                    new ProcessMessageParameter { Name = "IITR311", Value = GetValueOrEmpty(report.IITR311) },
                    new ProcessMessageParameter { Name = "IITR316", Value = GetValueOrEmpty(report.IITR316) },
                    new ProcessMessageParameter { Name = "IITR318", Value = GetValueOrEmpty(report.IITR318) },
                    new ProcessMessageParameter { Name = "IITR321", Value = GetValueOrEmpty(report.IITR321) },
                    new ProcessMessageParameter { Name = "IITR322", Value = GetValueOrEmpty(report.IITR322) },
                    new ProcessMessageParameter { Name = "IITR323", Value = GetValueOrEmpty(report.IITR323) },
                    new ProcessMessageParameter { Name = "IITR324", Value = GetValueOrEmpty(report.IITR324) },
                    new ProcessMessageParameter { Name = "IITR327", Value = GetValueOrEmpty(report.IITR327) },
                    new ProcessMessageParameter { Name = "IITR328", Value = GetValueOrEmpty(report.IITR328) },
                    new ProcessMessageParameter { Name = "IITR334", Value = GetValueOrEmpty(report.IITR334) },
                    new ProcessMessageParameter { Name = "IITR335", Value = GetValueOrEmpty(report.IITR335) },
                    new ProcessMessageParameter { Name = "IITR336", Value = GetValueOrEmpty(report.IITR336) },
                    new ProcessMessageParameter { Name = "IITR337", Value = GetValueOrEmpty(report.IITR337) },
                    new ProcessMessageParameter { Name = "IITR339", Value = GetValueOrEmpty(report.IITR339) },
                    new ProcessMessageParameter { Name = "IITR341", Value = GetValueOrEmpty(report.IITR341) },
                    new ProcessMessageParameter { Name = "IITR615", Value = GetValueOrEmpty(report.IITR615) },
                    new ProcessMessageParameter { Name = "IITR616", Value = GetValueOrEmpty(report.IITR616) },
                    new ProcessMessageParameter { Name = "IITR650", Value = GetValueOrEmpty(report.IITR650) },
                    new ProcessMessageParameter { Name = "IITR618", Value = GetValueOrEmpty(report.IITR618) }, },
                };

                response.Add(processMessage);
            }
        }

        #endregion // VR.ATO.IITR.000263

        #region VR.ATO.IITR.730163

        /* VR.ATO.IITR.730163
        When an amount above zero is provided for "Foreign income tax offset", the "Net foreign employment income - payment summary" amount must not exceed the sum of "Salary or wages gross income", "Salary or wages lump sum A" and "Tax withheld - lump sum payments in arrears"
    
        Legacy Rule Format:
        (^IITR331 > 0) AND (^IITR329 > (^IITR601 + ^IITR607 + ^IITR354))

        Technical Business Rule Format:
        (^IITR331 > 0) AND (^IITR329 > (^IITR601 + ^IITR607 + ^IITR354))
    
        Data Elements:
    
        ^IITR331 = RP:Income.InternationalDealings.TaxOffset.Amount
    
        ^IITR329 = RP:InternationalDealings.ForeignEmploymentIncomePaymentSummary.Amount
    
        ^IITR354 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldLumpSumPaymentsInArrears.Amount
    
        ^IITR601 = RP:Income.SalaryOrWages.Amount
    
        ^IITR607 = RP:Income.UnusedAnnualOrLongServiceLeavePaymentLumpSumA.Amount
        */
        protected void VRATOIITR730163(List<ProcessMessageDocument> response, IITR2021 report)
        {
            ProcessMessageDocument processMessage;
            bool assertion;

            decimal sumOf_IITR601_IITR607_IITR354 = report.IITR601.GetValueOrDefault() + report.IITR607.GetValueOrDefault() + report.IITR354.GetValueOrDefault();

            assertion = (report.IITR331.GetValueOrDefault() > 0 && report.IITR329.GetValueOrDefault() > sumOf_IITR601_IITR607_IITR354);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730163",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Foreign income tax offset is incorrect",
                    LongDescription = @"When an amount above zero is provided for ""Foreign income tax offset"", the ""Net foreign employment income - payment summary"" amount must not exceed the sum of ""Salary or wages gross income"", ""Salary or wages lump sum A"" and ""Tax withheld - lump sum payments in arrears""",
                    Location = "/xbrli:xbrl/tns:Income.InternationalDealings.TaxOffset.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730163" },
                    new ProcessMessageParameter { Name = "IITR331", Value = GetValueOrEmpty(report.IITR331) },
                    new ProcessMessageParameter { Name = "IITR329", Value = GetValueOrEmpty(report.IITR329) },
                    new ProcessMessageParameter { Name = "([iitr601] + [iitr607] + [iitr354])", Value = sumOf_IITR601_IITR607_IITR354.ToString() },
                    new ProcessMessageParameter { Name = "IITR601", Value = GetValueOrEmpty(report.IITR601) },
                    new ProcessMessageParameter { Name = "IITR607", Value = GetValueOrEmpty(report.IITR607) },
                    new ProcessMessageParameter { Name = "IITR354", Value = GetValueOrEmpty(report.IITR354) },
                    },
                };
                response.Add(processMessage);
            }
        }

        #endregion // VR.ATO.IITR.730163

        #region VR.ATO.IITR.630005

        /* VR.ATO.IITR.630005
        Check Total Tax Withheld amount is greater than or equal to the sum of the Income amounts.
    
        Legacy Rule Format:
        ^IITR113 >= (^IITR601 + ^IITR65 + ^IITR607 + ^IITR609 + ^IITR626 + ^IITR86 + ^IITR89 + ^IITR92 + ^IITR93 + ^IITR505 + ^IITR94 + ^IITR95 + ^IITR611 + ^IITR612 + ^IITR112)

        Technical Business Rule Format:
        ^IITR113 >= (^IITR601 + ^IITR65 + ^IITR607 + ^IITR609 + ^IITR626 + ^IITR86 + ^IITR89 + ^IITR92 + ^IITR93 + ^IITR505 + ^IITR94 + ^IITR95 + ^IITR611 + ^IITR612 + ^IITR112)
    
        Data Elements:
    
        ^IITR113 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheld.Amount
    
        ^IITR65 = RP:Income.AllowancesEarningsTipsDirectorsFees.Amount
    
        ^IITR86 = RP:Income.AustralianGovernmentAllowancesAndPayments.Amount
    
        ^IITR89 = RP:Pension.Total.Amount
    
        ^IITR92 = RP:Income.Superannuation.AnnuitiesAndSuperannuationTaxableComponentTaxedElement.Amount
    
        ^IITR93 = RP:Income.Superannuation.AnnuitiesAndSuperannuationTaxableComponentUntaxedElement.Amount
    
        ^IITR94 = RP:Income.Superannuation.AnnuitiesAndSuperannuationLumpSumArrearsTaxableComponentTaxedElement.Amount
    
        ^IITR95 = RP:Income.Superannuation.AnnuitiesAndSuperannuationLumpSumArrearsTaxableComponentUntaxedElement.Amount
    
        ^IITR112 = RP:Income.PersonalServicesIncome.Total.Amount
    
        ^IITR505 = RP:Income.Superannuation.AnnuitiesAndSuperannuationAssessableCappedBenefit.Amount
    
        ^IITR601 = RP:Income.SalaryOrWages.Amount
    
        ^IITR607 = RP:Income.UnusedAnnualOrLongServiceLeavePaymentLumpSumA.Amount
    
        ^IITR609 = RP:Income.UnusedAnnualOrLongServiceLeavePaymentLumpSumB.Amount
    
        ^IITR611 = RP:Income.Superannuation.LumpSumPaymentTaxableComponentTaxedElement.Amount
    
        ^IITR612 = RP:Income.Superannuation.LumpSumPaymentTaxableComponentUntaxedElement.Amount
    
        ^IITR626 = RP:Income.EmploymentTerminationPaymentTaxable.Amount
        */
        protected void VRATOIITR630005(List<ProcessMessageDocument> response, IITR2021 report)
        {
            ProcessMessageDocument processMessage;
            bool assertion = false;
            decimal sumOfIncomeAmounts = report.IITR601.GetValueOrDefault() + report.IITR65.GetValueOrDefault() + report.IITR607.GetValueOrDefault() + report.IITR609.GetValueOrDefault() + report.IITR626.GetValueOrDefault() + report.IITR86.GetValueOrDefault() + report.IITR89.GetValueOrDefault() + report.IITR92.GetValueOrDefault() + report.IITR93.GetValueOrDefault() + report.IITR505.GetValueOrDefault() + report.IITR94.GetValueOrDefault() + report.IITR95.GetValueOrDefault() + report.IITR611.GetValueOrDefault() + report.IITR612.GetValueOrDefault() + report.IITR112.GetValueOrDefault();

            if (report.IITR113 != null){
                assertion = (report.IITR113.GetValueOrDefault() >= sumOfIncomeAmounts);
            }

            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.630005",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Check Tax Withheld against Income",
                    LongDescription = @"Check the Tax Withheld amount as the amount is greater than or equal to the sum of Income amounts from Salary and Wages to Attributed personal services income.",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheld.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.630005" },
                    new ProcessMessageParameter { Name = "IITR113", Value = GetValueOrEmpty(report.IITR113) },
                    new ProcessMessageParameter { Name = "Sum of income amounts", Value = sumOfIncomeAmounts.ToString() },
                    new ProcessMessageParameter { Name = "IITR601", Value = GetValueOrEmpty(report.IITR601) },
                    new ProcessMessageParameter { Name = "IITR65", Value = GetValueOrEmpty(report.IITR65) },
                    new ProcessMessageParameter { Name = "IITR607", Value = GetValueOrEmpty(report.IITR607) },
                    new ProcessMessageParameter { Name = "IITR609", Value = GetValueOrEmpty(report.IITR609) },
                    new ProcessMessageParameter { Name = "IITR626", Value = GetValueOrEmpty(report.IITR626) },
                    new ProcessMessageParameter { Name = "IITR86", Value = GetValueOrEmpty(report.IITR86) },
                    new ProcessMessageParameter { Name = "IITR89", Value = GetValueOrEmpty(report.IITR89) },
                    new ProcessMessageParameter { Name = "IITR92", Value = GetValueOrEmpty(report.IITR92) },
                    new ProcessMessageParameter { Name = "IITR93", Value = GetValueOrEmpty(report.IITR93) },
                    new ProcessMessageParameter { Name = "IITR505", Value = GetValueOrEmpty(report.IITR505) },
                    new ProcessMessageParameter { Name = "IITR94", Value = GetValueOrEmpty(report.IITR94) },
                    new ProcessMessageParameter { Name = "IITR95", Value = GetValueOrEmpty(report.IITR95) },
                    new ProcessMessageParameter { Name = "IITR611", Value = GetValueOrEmpty(report.IITR611) },
                    new ProcessMessageParameter { Name = "IITR612", Value = GetValueOrEmpty(report.IITR612) },
                    new ProcessMessageParameter { Name = "IITR112", Value = GetValueOrEmpty(report.IITR112) },
                    },
                };

                response.Add(processMessage);
            }
        }

        #endregion // VR.ATO.IITR.630005

        #region VR.ATO.IITR.000236

        /* VR.ATO.IITR.000236
        Total tax withheld does not equal the sum of all tax withheld items
    
        Legacy Rule Format:
        ((^IITR113 <> NULL) AND (^IITR113 <> (^IITR85 + ^IITR88 + ^IITR600 + ^IITR606 + ^IITR608 + ^IITR91 + ^IITR111 + ^IITR64 + ^IITR625 + ^IITR610))) OR ((^IITR113 = NULL) AND ((^IITR85 + ^IITR88 + ^IITR600 + ^IITR606 + ^IITR608 + ^IITR91 + ^IITR111 + ^IITR625 + ^IITR610) <> 0))

        Technical Business Rule Format:
        ((^IITR113 <> NULL) AND (^IITR113 <> (^IITR85 + ^IITR88 + ^IITR600 + ^IITR606 + ^IITR608 + ^IITR91 + ^IITR111 + ^IITR64 + ^IITR625 + ^IITR610))) OR ((^IITR113 = NULL) AND ((^IITR85 + ^IITR88 + ^IITR600 + ^IITR606 + ^IITR608 + ^IITR91 + ^IITR111 + ^IITR625 + ^IITR610) <> 0))
    
        Data Elements:
    
        ^IITR113 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheld.Amount
    
        ^IITR64 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldAllowancesEarningsTipsDirectorsFees.Amount
    
        ^IITR85 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldAustralianGovernmentAllowancesAndPayments.Amount
    
        ^IITR88 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldAustralianGovernmentPensionsAndAllowances.Amount
    
        ^IITR91 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldAustralianAnnuitiesAndSuperannuationIncomeStream.Amount
    
        ^IITR111 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldPersonalServicesIncome.Amount
    
        ^IITR600 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldSalaryOrWages.Amount
    
        ^IITR606 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldUnusedAnnualOrLongServiceLeavePaymentLumpSumA.Amount
    
        ^IITR608 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldUnusedAnnualOrLongServiceLeavePaymentLumpSumB.Amount
    
        ^IITR610 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldSuperannuationLumpSumPayment.Amount
    
        ^IITR625 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldEmploymentTerminationPayment.Amount
        */
        protected void VRATOIITR000236(List<ProcessMessageDocument> response, IITR2021 report)
        {
            ProcessMessageDocument processMessage;
            bool assertion;
            decimal sumOfTaxWithHeldItems = report.IITR85.GetValueOrDefault() + report.IITR88.GetValueOrDefault() + report.IITR600.GetValueOrDefault() + report.IITR606.GetValueOrDefault() + report.IITR608.GetValueOrDefault() + report.IITR91.GetValueOrDefault() + report.IITR111.GetValueOrDefault() + report.IITR64.GetValueOrDefault() + report.IITR625.GetValueOrDefault() + report.IITR610.GetValueOrDefault();

            assertion = (report.IITR113 != null && report.IITR113.GetValueOrDefault() != sumOfTaxWithHeldItems) || (report.IITR113 == null && sumOfTaxWithHeldItems != 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000236",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Total tax withheld incorrect",
                    LongDescription = @"Total tax withheld must equal the sum of all tax withheld items",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheld.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000236" },
                    new ProcessMessageParameter { Name = "IITR113", Value = GetValueOrEmpty(report.IITR113) },
                    new ProcessMessageParameter { Name = "Sum of Tax withheld items", Value = sumOfTaxWithHeldItems.ToString() },
                    new ProcessMessageParameter { Name = "IITR85", Value = GetValueOrEmpty(report.IITR85) },
                    new ProcessMessageParameter { Name = "IITR88", Value = GetValueOrEmpty(report.IITR88) },
                    new ProcessMessageParameter { Name = "IITR600", Value = GetValueOrEmpty(report.IITR600) },
                    new ProcessMessageParameter { Name = "IITR606", Value = GetValueOrEmpty(report.IITR606) },
                    new ProcessMessageParameter { Name = "IITR608", Value = GetValueOrEmpty(report.IITR608) },
                    new ProcessMessageParameter { Name = "IITR91", Value = GetValueOrEmpty(report.IITR91) },
                    new ProcessMessageParameter { Name = "IITR111", Value = GetValueOrEmpty(report.IITR111) },
                    new ProcessMessageParameter { Name = "IITR64", Value = GetValueOrEmpty(report.IITR64) },
                    new ProcessMessageParameter { Name = "IITR625", Value = GetValueOrEmpty(report.IITR625) },
                    new ProcessMessageParameter { Name = "IITR610", Value = GetValueOrEmpty(report.IITR610) },
                    },
                };

                response.Add(processMessage);
            }
        }

        #endregion // VR.ATO.IITR.000236

        #region VR.ATO.IITR.730435

        /* VR.ATO.IITR.730435
        The sum of Primary production deferred losses and Non-primary production deferred losses must be equal to the sum of Business loss activity - Net loss amount where the Business loss activity - Type of Loss is "8" (loss is to be deferred)
    
        Legacy Rule Format:
        (^IITR299 <> NULL OR ^IITR300 <> NULL) AND (^IITR299 + ^IITR300 <> Sum(ConditionalValue(^IITR482 = '8', ^IITR487, 0)))
        
        Technical Business Rule Format:
        (^IITR299 <> NULL OR ^IITR300 <> NULL) AND (^IITR299 + ^IITR300 <> Sum(ConditionalValue(^IITR482 = '8', ^IITR487, 0)))
            
        Data Elements:
            
        ^IITR299 = RP:Tax.Losses.DeferredNonCommercialPrimaryProduction.Amount
            
        ^IITR300 = RP:Tax.Losses.DeferredNonCommercialNonPrimaryProduction.Amount
            
        ^IITR482 = RP.{LOSSSeqNum}:IncomeTax.LossesType.Code
            
        ^IITR487 = RP.{LOSSSeqNum}:Tax.Losses.Net.Amount
        */
        protected void VRATOIITR730435(List<ProcessMessageDocument> response, IITR2021 report)
        {
            ProcessMessageDocument processMessage;

            bool notNullIITR299_IITR300 = (report.IITR299 != null || report.IITR300 != null);
            decimal sumOfIITR299_IITR300 = report.IITR299.GetValueOrDefault() + report.IITR300.GetValueOrDefault();
            decimal sumOfIITR487 = 0;

            if (report.RPLOSSSeqNumContextCollection != null)
            {
                // Loop through the RPLOSSSEQNUMContextCollection and sum IITR487 where IITR482 is equal to "8"
                sumOfIITR487 = report.RPLOSSSeqNumContextCollection.Sum(context => !string.IsNullOrEmpty(context.IITR482) ? 
                    context.IITR482.Equals("8") ? context.IITR487.GetValueOrDefault() : 0 
                    : 0);
            }

            if (notNullIITR299_IITR300 && (sumOfIITR299_IITR300 != sumOfIITR487))
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730435",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Primary production and/or Non-primary production deferred losses amount incorrect",
                    LongDescription = @"The sum of Primary production deferred losses and Non-primary production deferred losses must be equal to the sum of Business loss activity - Net loss amount where the Business loss activity - Type of Loss is ""8"" (loss is to be deferred)",
                    Location = "/xbrli:xbrl/tns:Tax.Losses.DeferredNonCommercialPrimaryProduction.Amount[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730435" },
                    new ProcessMessageParameter { Name = "[iitr299] <> NULL", Value = (report.IITR299 != null ? report.IITR299.GetValueOrDefault().ToString() : "null") },
                    new ProcessMessageParameter { Name = "[iitr300] <> NULL", Value = (report.IITR300 != null ? report.IITR300.GetValueOrDefault().ToString() : "null") },
                    new ProcessMessageParameter { Name = "[iitr299] + [iitr300]", Value = sumOfIITR299_IITR300.ToString() },
                    new ProcessMessageParameter { Name = @"SUM(ConditionalValue([iitr482] = ""8"", [iitr487], 0))", Value = sumOfIITR487.ToString() },
                    },
                };
                response.Add(processMessage);
            }
        }

        #endregion // VR.ATO.IITR.730435

        #endregion Manual Rules - Rules marked for manual coding

        #region ValidateCrossFormRules

        public List<ProcessMessageDocument> ValidateCrossFormRules(IITR2021 report)
        {
            List<ProcessMessageDocument> response = new List<ProcessMessageDocument>();
            #region Cross Form Rules
            VRATOGEN438022(response, report);
            VRATOGEN438023(response, report);
            VRATOGEN438024(response, report);
            VRATOGEN438025(response, report);
            VRATOGEN438026(response, report);
            VRATOGEN438027(response, report);
            VRATOIITR000639(response, report);
            VRATOIITR000641(response, report);
            VRATOIITR000642(response, report);
            VRATOIITR000643(response, report);
            VRATOIITR000644(response, report);
            VRATOIITR000651(response, report); 
            VRATOIITR300041(response, report);
            VRATOIITR300042(response, report);
            VRATOIITR300043(response, report);
            VRATOIITR300044(response, report);
            VRATOIITR300045(response, report);
            VRATOIITR300046(response, report);
            VRATOIITR300047(response, report);
            VRATOIITR300048(response, report);
            VRATOIITR300049(response, report);
            VRATOIITR300050(response, report);
            VRATOIITR300051(response, report);
            VRATOIITR300052(response, report);
            VRATOIITR300084(response, report);
            VRATOIITR300085(response, report);
            VRATOIITR300086(response, report);
            VRATOIITR300093(response, report); 
            VRATOIITR310021(response, report);
            VRATOIITR310037(response, report);
            VRATOIITR310039(response, report);
            VRATOIITR310063(response, report);
            VRATOIITR310066(response, report);
            VRATOIITR310067(response, report);
            VRATOIITR310068(response, report);
            VRATOIITR310069(response, report);
            VRATOIITR310070(response, report);
            VRATOIITR310071(response, report);
            VRATOIITR310083(response, report);
            VRATOIITR310084(response, report);
            VRATOIITR310088(response, report);
            VRATOIITR310089(response, report);
            VRATOIITR310090(response, report);
            VRATOIITR310093(response, report);
            VRATOIITR310094(response, report);
            VRATOIITR310095(response, report);
            VRATOIITR400059(response, report);
            VRATOIITR400059_(response, report);
            VRATOIITR400059__(response, report);
            VRATOIITR400059___(response, report);
            VRATOIITR400059____(response, report);
            VRATOIITR400059_____(response, report);
            VRATOIITR400059______(response, report);
            VRATOIITR400059_______(response, report);
            VRATOIITR400059________(response, report);
            VRATOIITR400059_________(response, report);
            VRATOIITR400059__________(response, report);
            VRATOIITR400059___________(response, report);
            VRATOIITR400059____________(response, report);
            VRATOIITR400059_____________(response, report);
            VRATOIITR400059______________(response, report);
            VRATOIITR400059_______________(response, report);
            VRATOIITR400059________________(response, report);
            VRATOIITR400059_________________(response, report);
            VRATOIITR400059__________________(response, report);
            VRATOIITR400059___________________(response, report);
            VRATOIITR400059____________________(response, report);
            VRATOIITR400059_____________________(response, report);
            VRATOIITR400059______________________(response, report);
            VRATOIITR400059_______________________(response, report);
            VRATOIITR400059________________________(response, report);
            VRATOIITR400059_________________________(response, report);
            VRATOIITR400059__________________________(response, report);
            VRATOIITR400060(response, report);
            VRATOIITR400060_(response, report);
            VRATOIITR400060__(response, report);
            VRATOIITR400060___(response, report);
            VRATOIITR400060____(response, report);
            VRATOIITR400060_____(response, report);
            VRATOIITR400060______(response, report);
            VRATOIITR400060_______(response, report);
            VRATOIITR400060________(response, report);
            VRATOIITR400060_________(response, report);
            VRATOIITR400060__________(response, report);
            VRATOIITR400060___________(response, report);
            VRATOIITR400060____________(response, report);
            VRATOIITR400060_____________(response, report);
            VRATOIITR400060______________(response, report);
            VRATOIITR400060_______________(response, report);
            VRATOIITR400060________________(response, report);
            VRATOIITR400060_________________(response, report);
            VRATOIITR400060__________________(response, report);
            VRATOIITR400060___________________(response, report);
            VRATOIITR400060____________________(response, report);
            VRATOIITR400060_____________________(response, report);
            VRATOIITR400060______________________(response, report);
            VRATOIITR400060_______________________(response, report);
            VRATOIITR400060________________________(response, report);
            VRATOIITR400060_________________________(response, report);
            VRATOIITR400060__________________________(response, report);
            VRATOIITR600014(response, report);
            VRATOIITR600024(response, report);
            VRATOIITR600031(response, report);
            VRATOIITR600046(response, report);
            VRATOIITR700304(response, report);
            VRATOIITR730000(response, report);
            VRATOIITR730001(response, report);
            VRATOIITR730002(response, report);
            VRATOIITR730003(response, report);
            VRATOIITR730050(response, report);
            VRATOIITR730051(response, report);
            VRATOIITR730052(response, report);
            VRATOIITR730053(response, report);
            VRATOIITR730054(response, report);
            VRATOIITR730055(response, report);
            VRATOIITR730056(response, report);
            VRATOIITR730057(response, report);
            VRATOIITR730058(response, report);
            VRATOIITR730059(response, report);
            VRATOIITR730100(response, report);
            VRATOIITR730101(response, report);
            VRATOIITR730102(response, report);
            VRATOIITR730103(response, report);
            VRATOIITR730104(response, report);
            VRATOIITR730105(response, report);
            VRATOIITR730106(response, report);
            VRATOIITR730107(response, report);
            VRATOIITR730150(response, report);
            VRATOIITR730200(response, report);
            VRATOIITR730201(response, report);
            VRATOIITR730202(response, report);
            VRATOIITR730203(response, report);
            VRATOIITR730204(response, report);
            VRATOIITR730205(response, report);
            VRATOIITR730206(response, report);
            VRATOIITR730207(response, report);
            VRATOIITR730208(response, report);
            VRATOIITR730209(response, report);
            VRATOIITR730210(response, report);
            VRATOIITR730211(response, report);
            VRATOIITR730212(response, report);
            VRATOIITR730213(response, report);
            VRATOIITR730214(response, report);
            VRATOIITR730215(response, report);
            VRATOIITR730216(response, report);
            VRATOIITR730217(response, report);
            VRATOIITR730218(response, report);
            VRATOIITR730219(response, report);
            VRATOIITR730220(response, report);
            VRATOIITR730221(response, report);
            VRATOIITR730300(response, report);
            VRATOIITR730301(response, report);
            VRATOIITR730302(response, report);
            VRATOIITR730304(response, report);
            VRATOIITR730305(response, report);
            VRATOIITR730306(response, report);
            VRATOIITR730307(response, report);
            VRATOIITR730308(response, report); 
            VRATOIITR730310(response, report);
            VRATOIITR730311(response, report);
            VRATOIITR730311_(response, report);
            VRATOIITR730311__(response, report);
            VRATOIITR730311___(response, report);
            VRATOIITR730311____(response, report);
            VRATOIITR730311_____(response, report);
            VRATOIITR730311______(response, report);
            VRATOIITR730311_______(response, report);
            VRATOIITR730311________(response, report);
            VRATOIITR730311_________(response, report);
            VRATOIITR730311__________(response, report);
            VRATOIITR730311___________(response, report);
            VRATOIITR730311____________(response, report);
            VRATOIITR730311_____________(response, report);
            VRATOIITR730311______________(response, report);
            VRATOIITR730311_______________(response, report);
            VRATOIITR730311________________(response, report);
            VRATOIITR730311_________________(response, report);
            VRATOIITR730311__________________(response, report);
            VRATOIITR730311___________________(response, report);
            VRATOIITR730311____________________(response, report);
            VRATOIITR730311_____________________(response, report);
            VRATOIITR730311______________________(response, report);
            VRATOIITR730311_______________________(response, report);
            VRATOIITR730311________________________(response, report);
            VRATOIITR730311_________________________(response, report);
            VRATOIITR730311__________________________(response, report);
            VRATOIITR730312(response, report);
            VRATOIITR730312_(response, report);
            VRATOIITR730312__(response, report);
            VRATOIITR730312___(response, report);
            VRATOIITR730312____(response, report);
            VRATOIITR730312_____(response, report);
            VRATOIITR730312______(response, report);
            VRATOIITR730312_______(response, report);
            VRATOIITR730312________(response, report);
            VRATOIITR730312_________(response, report);
            VRATOIITR730312__________(response, report);
            VRATOIITR730312___________(response, report);
            VRATOIITR730312____________(response, report);
            VRATOIITR730312_____________(response, report);
            VRATOIITR730312______________(response, report);
            VRATOIITR730312_______________(response, report);
            VRATOIITR730312________________(response, report);
            VRATOIITR730312_________________(response, report);
            VRATOIITR730312__________________(response, report);
            VRATOIITR730312___________________(response, report);
            VRATOIITR730312____________________(response, report);
            VRATOIITR730312_____________________(response, report);
            VRATOIITR730312______________________(response, report);
            VRATOIITR730312_______________________(response, report);
            VRATOIITR730312________________________(response, report);
            VRATOIITR730312_________________________(response, report);
            VRATOIITR730312__________________________(response, report);
            VRATOIITR730313(response, report);
            #endregion Cross Form Rules
            return response;
        }

        #endregion
    }
}
